<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" doctype-public="-//W3C//DTD HTML 4.01 Strict//EN" 
		doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" 
		omit-xml-declaration="yes"/>
    <xsl:template match="/">
		<html>
			<head>
				<style>
					caption 
					{
						font-family: "Verdana"; 
						font-size: 15pt; 
						text-align: left;
						padding-top: 10px;
						color: #4CAF50;
					}
					table
					{
						padding-bottom: 10px;
						/* border: 1px solid black; */
						/* border-collapse: collapse; */
					}
					th, td
					{
						/* border: 1px solid black; */
						font-family: "Verdana";
						font-size: 9pt;
						padding-left: 10px;
						padding-right: 10px;
						white-space: nowrap;
						text-align: left;
					}
					p 
					{
						visibility: hidden;
					}
					#rechts
					{
						text-align: right;
					}
				</style>
			</head>
			<body onload="Hide()">
				<div>
					<table class="Kopf_Ausblenden">
						<caption class="Color">Belegkopf</caption>
						<tr>
							<th>Belegdatum</th>
							<th>Periode</th>
							<th>Belegnummer</th>
							<th class="Kopf_Fremdwaehrung">Betrag [W]</th>
							<th class="Kopf_Fremdwaehrung">[W]</th>
							<th class="Kopf_Fremdwaehrung">Kurs</th>
							<th>Betrag HW</th>
							<th>Buchungstext</th>
							<th class="Kopf_Belegart">Buchungsart</th>
							<th class="Kopf_DmsId">DMS Dokumentenname</th>
						</tr>
						<xsl:for-each select="/Beleg/Belegkopf">
							<tr>
								<td id="rechts">
									<xsl:value-of select="Kopf_BelegDatum"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kopf_Periode"/>
								</td>
								<td>
									<xsl:value-of select="Kopf_Belegnummer"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_BetragFW"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_Waehrung"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_Kurs"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kopf_BetragHW"/>
								</td>
								<td>
									<xsl:value-of select="Kopf_Buchungstext"/>
								</td>
								<td class="Kopf_Belegart">
									<xsl:value-of select="Kopf_Belegart"/>
								</td>
								<td class="Kopf_DmsId">
									<xsl:value-of select="Kopf_DmsId"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Zeilen_Ausblenden">
						<caption class="Color">Belegzeilen</caption>
						<tr>
							<th class="Zeilen_Zeilen">Zeile</th>
							<th>Soll</th>
							<th>Haben</th>
							<th class="Kopf_Fremdwaehrung">Betrag [W]</th>
							<th>Betrag HW</th>
							<th>Buchungstext</th>
							<th class="Zeilen_SteuerinfosHW">Steuerart</th>
							<th class="Zeilen_SteuerinfosHW">Steuer-%</th>
							<th class="Zeilen_SteuerinfosFW">Steuer [W]</th>
							<th class="Zeilen_SteuerinfosHW">Steuer HW</th>
						</tr>
						<xsl:for-each select="/Beleg/Belegzeilen/Belegzeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Zeilen_Zeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_Soll"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_Haben"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Zeilen_BetragFW"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_BetragHW"/>
								</td>
								<td>
									<xsl:value-of select="Zeilen_Buchungstext"/>
								</td>
								<td class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_Name"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_Prozent"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosFW">
									<xsl:value-of select="Zeilen_Steuer_BetragFW"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_BetragHW"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Zusaetze_Ausblenden">
						<caption class="Color">Belegzusätze</caption>
						<xsl:for-each select="/Beleg/Belegzusaetze/Belegzusatz">
							<tr>
								<td>
									<xsl:value-of select="Zusatze_Name"/>
								</td>
								<td>
									<xsl:value-of select="Zusatze_Text"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="SOP_Ausblenden">
						<caption class="Color">SOP</caption>
						<tr>
							<th class="SOP_Zeilen">Zeile</th>
							<th>Aktion</th>
							<th class="SOP_Infos">SOP-Belegnummer</th>
							<th class="SOP_Infos">SOP_RechNr</th>
							<th class="SOP_Infos">Ausstand vorher [W]</th>
							<th class="SOP_Ausstand_Nachher">Ausstand nachher [W]</th>
							<th class="Kopf_Fremdwaehrung">[W]</th>
							<th class="SOP_Infos">SOP-Bemerkung</th>
						</tr>
						<xsl:for-each select="/Beleg/SOPs/SOP">
							<tr>
								<td id="rechts" class="SOP_Zeilen">
									<xsl:value-of select="SOP_Zeile"/>
								</td>
								<td>
									<xsl:value-of select="SOP_Aktion"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_Belegnummer"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_RechNr"/>
								</td>
								<td id="rechts" class="SOP_Infos">
									<xsl:value-of select="SOP_Ausstand_vorher"/>
								</td>
								<td id="rechts" class="SOP_Ausstand_Nachher">
									<xsl:value-of select="SOP_Ausstand_nachher"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="SOP_Waehrung"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_Bemerkung"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="AZ_Ausblenden">
						<caption class="Color">Anzahlungs-Fall</caption>
						<tr>
							<th>AZ-Fall-Nr.</th>
							<th>AZ-Fall-Name</th>
						</tr>
						<xsl:for-each select="/Beleg/AZ_Faelle/AZ_Fall">
							<tr>
								<td id="rechts">
									<xsl:value-of select="AZ_Nummer"/>
								</td>
								<td>
									<xsl:value-of select="AZ_Name"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="OP_Ausblenden">
						<caption class="Color">OPos</caption>
						<tr>
							<th class="OP_Zeilen">Zeile</th>
							<th>Aktion</th>
							<th>OP-RechNr</th>
							<th>OP-BelegNr</th>
							<th class="Kopf_Fremdwaehrung">Zahlung [W]</th>
							<th class="Kopf_Fremdwaehrung">[W]</th>
							<th>Zahlung HW</th>
							<th class="OP_Abzug">Abzug</th>
							<th class="OP_Ausstand_Nachher_FW">Ausstand nachher [W]</th>
							<th class="OP_Ausstand_Nachher_HW">Ausstand nachher HW</th>
							<th>OP-Bemerkung</th>
							<th>Valuta-Datum</th>
							<th>Zahlziel</th>
						</tr>
						<xsl:for-each select="/Beleg/OPs/OP">
							<tr>
								<td id="rechts" class="OP_Zeilen">
									<xsl:value-of select="OP_Zeile"/>
								</td>
								<td>
									<xsl:value-of select="OP_Aktion"/>
								</td>
								<td>
									<xsl:value-of select="OP_Rechnungsnummer"/>
								</td>
								<td class="">
									<xsl:value-of select="OP_Belegnummer"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="OP_ZahlungFW"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="OP_WaehrungFW"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="OP_ZahlungHW"/>
								</td>
								<td id="rechts" class="OP_Abzug">
									<xsl:value-of select="OP_Abzug"/>
								</td>
								<td id="rechts" class="OP_Ausstand_Nachher_FW">
									<xsl:value-of select="OP_Ausstand_NachherFW"/>
								</td>
								<td id="rechts" class="OP_Ausstand_Nachher_HW">
									<xsl:value-of select="OP_Ausstand_NachherHW"/>
								</td>
								<td>
									<xsl:value-of select="OP_Bemerkung"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="OP_Valuta_Datum"/>
								</td>
								<td>
									<xsl:value-of select="OP_Zahlziel"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Kore_Ausblenden">
						<caption class="Color">Kore</caption>
						<tr>
							<th class="Zeilen_Zeilen">Fibu-Zeile</th>
							<th>lfd. Nr.</th>
							<th>Betrag</th>
							<th class="">KoArt</th>
							<th class="">KoStelle</th>
							<th class="Kore_KoTr1"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header1"/></th>
							<th class="Kore_KoTr2"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header2"/></th>
							<th class="Kore_KoTr3"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header3"/></th>
							<th class="Kore_KoTr4"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header4"/></th>
							<th class="Kore_KoTr5"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header5"/></th>
							<th class="">Fix/Var</th>
							<th class ="Kore_Menge">Menge</th>
							<th class ="Kore_Menge">Einheit</th>
						</tr>
						<xsl:for-each select="/Beleg/Korezeilen/Korezeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Kore_FibuZeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kore_LfdNr"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kore_Betrag"/>
								</td>
								<td>
									<xsl:value-of select="Kore_KoArt"/>
								</td>
								<td>
									<xsl:value-of select="Kore_KoSte"/>
								</td>
								<td class ="Kore_KoTr1">
									<xsl:value-of select="Kore_KoTr1"/>
								</td>
								<td class ="Kore_KoTr2">
									<xsl:value-of select="Kore_KoTr2"/>
								</td>
								<td class ="Kore_KoTr3">
									<xsl:value-of select="Kore_KoTr3"/>
								</td>
								<td class ="Kore_KoTr4">
									<xsl:value-of select="Kore_KoTr4"/>
								</td>
								<td class ="Kore_KoTr5">
									<xsl:value-of select="Kore_KoTr5"/>
								</td>
								<td>
									<xsl:value-of select="Kore_Fix"/>
								</td>
								<td id="rechts" class ="Kore_Menge">
									<xsl:value-of select="Kore_Menge"/>
								</td>
								<td class ="Kore_Menge">
									<xsl:value-of select="Kore_Einheit"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Anbu_Ausblenden">
						<caption class="Color">Anbu</caption>
						<tr>
							<th class="Zeilen_Zeilen">Fibu-Zeile</th>
							<th>Anlagenkonto</th>
							<th>Bewegungsart</th>
							<th>Betrag HW</th>
							<th class="Anbu_Restwert_Ausblenden">AfA HW</th>
							<th class="Anbu_Restwert_Ausblenden">Restwert HW</th>
							<th class="Anbu_InvNr_Ausblenden">InvNr.</th>
							<th class="Anbu_InvNr_Ausblenden">InvBez.</th>
						</tr>
						<xsl:for-each select="/Beleg/Anbuzeilen/Anbuzeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Anbu_FibuZeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Anbu_Konto"/>
								</td>
								<td>
									<xsl:value-of select="Anbu_Bewegart"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Anbu_Betrag"/>
								</td>
								<td id="rechts" class="Anbu_Restwert_Ausblenden">
									<xsl:value-of select="Anbu_Afa"/>
								</td>
								<td id="rechts" class="Anbu_Restwert_Ausblenden">
									<xsl:value-of select="Anbu_Restwert"/>
								</td>
								<td class ="Anbu_InvNr_Ausblenden">
									<xsl:value-of select="Anbu_InvNr"/>
								</td>
								<td class ="Anbu_InvNr_Ausblenden">
									<xsl:value-of select="Anbu_InvBezeichnung"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Anmerkungen_Ausblenden" id="Anmerkungen">
						<caption class="Color">Anmerkungen</caption>
						<tr>
							<th>Konto</th>
							<th>Anmerkung</th>
						</tr>
						<xsl:for-each select="/Beleg/Anmerkungen/Anmerkung">
							<tr>
								<td>
									<xsl:value-of select="Anmerkung_Konto"/>
								</td>
								<td>
									<xsl:value-of select="Anmerkung_Anmerkung"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</div>
				<p id="Color">
					<xsl:value-of select="Beleg/Data/Color"/>
				</p>
				<p id="Kopf_Ausblenden">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Ausblenden"/>
				</p>
				<p id="Kopf_Fremdwaehrung">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Fremdwaehrung_Ausblenden"/>
				</p>
				<p id="Kopf_Belegart">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Belegart_Ausblenden"/>
				</p>
				<p id="Kopf_DmsId">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_DmsId_Ausblenden"/>
				</p>
				<p id="Zeilen_Ausblenden">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Ausblenden"/>
				</p>
				<p id="Zeilen_Zeilen">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Zeilen_Ausblenden"/>
				</p>
				<p id="Zeilen_SteuerinfosFW">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Steuerinfos_AusblendenFW"/>
				</p>
				<p id="Zeilen_SteuerinfosHW">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Steuerinfos_AusblendenHW"/>
				</p>
				<p id="Zusaetze_Ausblenden">
					<xsl:value-of select="Beleg/Belegzusaetze/Belegzusaetze_Ausblenden"/>
				</p>
				<p id="SOP_Ausblenden">
					<xsl:value-of select="Beleg/SOPs/SOP_Ausblenden"/>
				</p>
				<p id="SOP_Zeilen">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Zeilen_Ausblenden"/>
				</p>
				<p id="SOP_Infos">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Infos_Ausblenden"/>
				</p>
				<p id="SOP_Ausstand_Nachher">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Ausstand_Nachher_Ausblenden"/>
				</p>
				<p id="AZ_Ausblenden">
					<xsl:value-of select="Beleg/AZ_Faelle/AZ_Ausblenden"/>
				</p>
				<p id="OP_Ausblenden">
					<xsl:value-of select="Beleg/OPs/OP_Ausblenden"/>
				</p>
				<p id="OP_Zeilen">
					<xsl:value-of select="Beleg/OPs/OP_Zeilen_Ausblenden"/>
				</p>
				<p id="OP_Abzug">
					<xsl:value-of select="Beleg/OPs/OP_Abzug_Ausblenden"/>
				</p>
				<p id="OP_Ausstand_Nachher_FW">
					<xsl:value-of select="Beleg/OPs/OP_Ausstand_Ausblenden_FW"/>
				</p>
				<p id="OP_Ausstand_Nachher_HW">
					<xsl:value-of select="Beleg/OPs/OP_Ausstand_Ausblenden_HW"/>
				</p>
				<p id="Kore_Ausblenden">
					<xsl:value-of select="Beleg/Korezeilen/Korezeilen_Ausblenden"/>
				</p>
				<p id="Kore_KoTr1">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr1_Ausblenden"/>
				</p>
				<p id="Kore_KoTr2">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr2_Ausblenden"/>
				</p>
				<p id="Kore_KoTr3">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr3_Ausblenden"/>
				</p>
				<p id="Kore_KoTr4">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr4_Ausblenden"/>
				</p>
				<p id="Kore_KoTr5">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr5_Ausblenden"/>
				</p>
				<p id="Kore_Menge">
					<xsl:value-of select="Beleg/Korezeilen/Kore_Menge_Ausblenden"/>
				</p>
				<p id="Anbu_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_Ausblenden"/>
				</p>
				<p id="Anbu_InvNr_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_InvNr_Ausblenden"/>
				</p>
				<p id="Anbu_Restwert_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_Restwert_Ausblenden"/>
				</p>
				<p id="Anmerkungen_Ausblenden">
					<xsl:value-of select="Beleg/Anmerkungen/Anmerkungen_Ausblenden"/>
				</p>
				<script language="javascript" type="text/javascript">	
					document.getElements = function(cl)
					{
						var retnode = [];
						var myclass = new RegExp('\\b'+cl+'\\b');
						var elem = this.getElementsByTagName('*');
						var i = 0;
						while( i != elem.length)
						{
							var classes = elem[i].className;
							if (myclass.test(classes)) retnode.push(elem[i]);
							i++;
						}
						return retnode;
					}						
					function Hide(e, p)
					{
						var ele = document.getElements('');
						var i = 0;
						while (i != ele.length)
						{
							if (ele[i].className == "Color")
							{
								var color = document.getElementById(ele[i].className).innerHTML;
								ele[i].style.color = color;
							}
							else
							{
								var status = document.getElementById(ele[i].className).innerHTML;
								ele[i].style.display = status;
							}
							i++;
						}
					}
				</script>
			</body>
		</html>
    </xsl:template>
</xsl:stylesheet>
