<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" doctype-public="-//W3C//DTD HTML 4.01 Strict//EN" 
		doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" 
		omit-xml-declaration="yes"/>
    <xsl:template match="/">
		<html>
			<head>
				<style>
					caption 
					{
						font-family: "Verdana"; 
						font-size: 15pt; 
						text-align: left;
						padding-top: 10px;
						color: #4CAF50;
					}
					table
					{
						padding-bottom: 10px;
						/* border: 1px solid black; */
						/* border-collapse: collapse; */
					}
					th, td
					{
						/* border: 1px solid black; */
						font-family: "Verdana";
						font-size: 9pt;
						padding-left: 10px;
						padding-right: 10px;
						white-space: nowrap;
						text-align: left;
					}
					p 
					{
						visibility: hidden;
					}
					#rechts
					{
						text-align: right;
					}
				</style>
			</head>
			<body onload="Hide()">
				<div>
					<table class="Kopf_Ausblenden">
						<caption class="Color">Document Header</caption>
						<tr>
							<th>Document date</th>
							<th>Period</th>
							<th>Document no.</th>
							<th class="Kopf_Fremdwaehrung">Amount [CUR]</th>
							<th class="Kopf_Fremdwaehrung">[CUR]</th>
							<th class="Kopf_Fremdwaehrung">Rate</th>
							<th>Amount LC</th>
							<th>Posting text</th>
							<th class="Kopf_Belegart">Posting type</th>
							<th class="Kopf_DmsId">DMS Document name</th>
						</tr>
						<xsl:for-each select="/Beleg/Belegkopf">
							<tr>
								<td id="rechts">
									<xsl:value-of select="Kopf_BelegDatum"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kopf_Periode"/>
								</td>
								<td>
									<xsl:value-of select="Kopf_Belegnummer"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_BetragFW"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_Waehrung"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Kopf_Kurs"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kopf_BetragHW"/>
								</td>
								<td>
									<xsl:value-of select="Kopf_Buchungstext"/>
								</td>
								<td class="Kopf_Belegart">
									<xsl:value-of select="Kopf_Belegart"/>
								</td>
								<td class="Kopf_DmsId">
									<xsl:value-of select="Kopf_DmsId"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Zeilen_Ausblenden">
						<caption class="Color">Document lines</caption>
						<tr>
							<th class="Zeilen_Zeilen">line</th>
							<th>Debit</th>
							<th>Credit</th>
							<th class="Kopf_Fremdwaehrung">Amount [CUR]</th>
							<th>Amount LC</th>
							<th>Posting text</th>
							<th class="Zeilen_SteuerinfosHW">Tax type</th>
							<th class="Zeilen_SteuerinfosHW">Tax-%</th>
							<th class="Zeilen_SteuerinfosFW">Tax [CUR]</th>
							<th class="Zeilen_SteuerinfosHW">Tax LC</th>
						</tr>
						<xsl:for-each select="/Beleg/Belegzeilen/Belegzeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Zeilen_Zeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_Soll"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_Haben"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="Zeilen_BetragFW"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Zeilen_BetragHW"/>
								</td>
								<td>
									<xsl:value-of select="Zeilen_Buchungstext"/>
								</td>
								<td class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_Name"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_Prozent"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosFW">
									<xsl:value-of select="Zeilen_Steuer_BetragFW"/>
								</td>
								<td id="rechts" class="Zeilen_SteuerinfosHW">
									<xsl:value-of select="Zeilen_Steuer_BetragHW"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Zusaetze_Ausblenden">
						<caption class="Color">additional document information</caption>
						<xsl:for-each select="/Beleg/Belegzusaetze/Belegzusatz">
							<tr>
								<td>
									<xsl:value-of select="Zusatze_Name"/>
								</td>
								<td>
									<xsl:value-of select="Zusatze_Text"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="SOP_Ausblenden">
						<caption class="Color">SR item</caption>
						<tr>
							<th class="SOP_Zeilen">line</th>
							<th>Activity</th>
							<th class="SOP_Infos">SR-Document no.</th>
							<th class="SOP_Infos">SRItemInvNo</th>
							<th class="SOP_Infos">Amount owed before [CUR]</th>
							<th class="SOP_Ausstand_Nachher">Amount owed after [CUR]</th>
							<th class="Kopf_Fremdwaehrung">[CUR]</th>
							<th class="SOP_Infos">OI note</th>
						</tr>
						<xsl:for-each select="/Beleg/SOPs/SOP">
							<tr>
								<td id="rechts" class="SOP_Zeilen">
									<xsl:value-of select="SOP_Zeile"/>
								</td>
								<td>
									<xsl:value-of select="SOP_Aktion"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_Belegnummer"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_RechNr"/>
								</td>
								<td id="rechts" class="SOP_Infos">
									<xsl:value-of select="SOP_Ausstand_vorher"/>
								</td>
								<td id="rechts" class="SOP_Ausstand_Nachher">
									<xsl:value-of select="SOP_Ausstand_nachher"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="SOP_Waehrung"/>
								</td>
								<td class="SOP_Infos">
									<xsl:value-of select="SOP_Bemerkung"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="AZ_Ausblenden">
						<caption class="Color">Advance payment event</caption>
						<tr>
							<th>adv.pay. event No.</th>
							<th>adv.pay. event name</th>
						</tr>
						<xsl:for-each select="/Beleg/AZ_Faelle/AZ_Fall">
							<tr>
								<td id="rechts">
									<xsl:value-of select="AZ_Nummer"/>
								</td>
								<td>
									<xsl:value-of select="AZ_Name"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="OP_Ausblenden">
						<caption class="Color">OPOS</caption>
						<tr>
							<th class="OP_Zeilen">line</th>
							<th>Activity</th>
							<th>OI invoice no.</th>
							<th>OI document no.</th>
							<th class="Kopf_Fremdwaehrung">Payment [CUR]</th>
							<th class="Kopf_Fremdwaehrung">[CUR]</th>
							<th>Payment LC</th>
							<th class="OP_Abzug">Deduction</th>
							<th class="OP_Ausstand_Nachher_FW">Amount owed post [CUR]</th>
							<th class="OP_Ausstand_Nachher_HW">Amount owed LC</th>
							<th>OI note</th>
							<th>for. curr. date</th>
							<th>pay-by date</th>
						</tr>
						<xsl:for-each select="/Beleg/OPs/OP">
							<tr>
								<td id="rechts" class="OP_Zeilen">
									<xsl:value-of select="OP_Zeile"/>
								</td>
								<td>
									<xsl:value-of select="OP_Aktion"/>
								</td>
								<td>
									<xsl:value-of select="OP_Rechnungsnummer"/>
								</td>
								<td class="">
									<xsl:value-of select="OP_Belegnummer"/>
								</td>
								<td id="rechts" class="Kopf_Fremdwaehrung">
									<xsl:value-of select="OP_ZahlungFW"/>
								</td>
								<td class="Kopf_Fremdwaehrung">
									<xsl:value-of select="OP_WaehrungFW"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="OP_ZahlungHW"/>
								</td>
								<td id="rechts" class="OP_Abzug">
									<xsl:value-of select="OP_Abzug"/>
								</td>
								<td id="rechts" class="OP_Ausstand_Nachher_FW">
									<xsl:value-of select="OP_Ausstand_NachherFW"/>
								</td>
								<td id="rechts" class="OP_Ausstand_Nachher_HW">
									<xsl:value-of select="OP_Ausstand_NachherHW"/>
								</td>
								<td>
									<xsl:value-of select="OP_Bemerkung"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="OP_Valuta_Datum"/>
								</td>
								<td>
									<xsl:value-of select="OP_Zahlziel"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Kore_Ausblenden">
						<caption class="Color">KORE</caption>
						<tr>
							<th class="Zeilen_Zeilen">FIBU line</th>
							<th>seq. no.</th>
							<th>Amount</th>
							<th class="">Cost type</th>
							<th class="">Cost center</th>
							<th class="Kore_KoTr1"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header1"/></th>
							<th class="Kore_KoTr2"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header2"/></th>
							<th class="Kore_KoTr3"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header3"/></th>
							<th class="Kore_KoTr4"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header4"/></th>
							<th class="Kore_KoTr5"><xsl:value-of select="/Beleg/Korezeilen/Kore_Header5"/></th>
							<th class="">Fix/Var</th>
							<th class ="Kore_Menge">Quantity</th>
							<th class ="Kore_Menge">Unit</th>
						</tr>
						<xsl:for-each select="/Beleg/Korezeilen/Korezeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Kore_FibuZeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kore_LfdNr"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Kore_Betrag"/>
								</td>
								<td>
									<xsl:value-of select="Kore_KoArt"/>
								</td>
								<td>
									<xsl:value-of select="Kore_KoSte"/>
								</td>
								<td class ="Kore_KoTr1">
									<xsl:value-of select="Kore_KoTr1"/>
								</td>
								<td class ="Kore_KoTr2">
									<xsl:value-of select="Kore_KoTr2"/>
								</td>
								<td class ="Kore_KoTr3">
									<xsl:value-of select="Kore_KoTr3"/>
								</td>
								<td class ="Kore_KoTr4">
									<xsl:value-of select="Kore_KoTr4"/>
								</td>
								<td class ="Kore_KoTr5">
									<xsl:value-of select="Kore_KoTr5"/>
								</td>
								<td>
									<xsl:value-of select="Kore_Fix"/>
								</td>
								<td id="rechts" class ="Kore_Menge">
									<xsl:value-of select="Kore_Menge"/>
								</td>
								<td class ="Kore_Menge">
									<xsl:value-of select="Kore_Einheit"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
					<table class="Anbu_Ausblenden">
						<caption class="Color">ANBU</caption>
						<tr>
							<th class="Zeilen_Zeilen">FIBU line</th>
							<th>fixed asset account</th>
							<th>Movement type</th>
							<th>Amount LC</th>
							<th class="Anbu_Restwert_Ausblenden">Dep. LC</th>
							<th class="Anbu_Restwert_Ausblenden">Remaining value LC</th>
							<th class="Anbu_InvNr_Ausblenden">InvtryNos</th>
							<th class="Anbu_InvNr_Ausblenden">InvtryDesig</th>
						</tr>
						<xsl:for-each select="/Beleg/Anbuzeilen/Anbuzeile">
							<tr>
								<td id="rechts" class="Zeilen_Zeilen">
									<xsl:value-of select="Anbu_FibuZeile"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Anbu_Konto"/>
								</td>
								<td>
									<xsl:value-of select="Anbu_Bewegart"/>
								</td>
								<td id="rechts">
									<xsl:value-of select="Anbu_Betrag"/>
								</td>
								<td id="rechts" class="Anbu_Restwert_Ausblenden">
									<xsl:value-of select="Anbu_Afa"/>
								</td>
								<td id="rechts" class="Anbu_Restwert_Ausblenden">
									<xsl:value-of select="Anbu_Restwert"/>
								</td>
								<td class ="Anbu_InvNr_Ausblenden">
									<xsl:value-of select="Anbu_InvNr"/>
								</td>
								<td class ="Anbu_InvNr_Ausblenden">
									<xsl:value-of select="Anbu_InvBezeichnung"/>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</div>
				<p id="Color">
					<xsl:value-of select="Beleg/Data/Color"/>
				</p>
				<p id="Kopf_Ausblenden">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Ausblenden"/>
				</p>
				<p id="Kopf_Fremdwaehrung">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Fremdwaehrung_Ausblenden"/>
				</p>
				<p id="Kopf_Belegart">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_Belegart_Ausblenden"/>
				</p>
				<p id="Kopf_DmsId">
					<xsl:value-of select="Beleg/Belegkopf/Kopf_DmsId_Ausblenden"/>
				</p>
				<p id="Zeilen_Ausblenden">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Ausblenden"/>
				</p>
				<p id="Zeilen_Zeilen">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Zeilen_Ausblenden"/>
				</p>
				<p id="Zeilen_SteuerinfosFW">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Steuerinfos_AusblendenFW"/>
				</p>
				<p id="Zeilen_SteuerinfosHW">
					<xsl:value-of select="Beleg/Belegzeilen/Zeilen_Steuerinfos_AusblendenHW"/>
				</p>
				<p id="Zusaetze_Ausblenden">
					<xsl:value-of select="Beleg/Belegzusaetze/Belegzusaetze_Ausblenden"/>
				</p>
				<p id="SOP_Ausblenden">
					<xsl:value-of select="Beleg/SOPs/SOP_Ausblenden"/>
				</p>
				<p id="SOP_Zeilen">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Zeilen_Ausblenden"/>
				</p>
				<p id="SOP_Infos">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Infos_Ausblenden"/>
				</p>
				<p id="SOP_Ausstand_Nachher">
					<xsl:value-of select="Beleg/SOPs/SOP/SOP_Ausstand_Nachher_Ausblenden"/>
				</p>
				<p id="AZ_Ausblenden">
					<xsl:value-of select="Beleg/AZ_Faelle/AZ_Ausblenden"/>
				</p>
				<p id="OP_Ausblenden">
					<xsl:value-of select="Beleg/OPs/OP_Ausblenden"/>
				</p>
				<p id="OP_Zeilen">
					<xsl:value-of select="Beleg/OPs/OP_Zeilen_Ausblenden"/>
				</p>
				<p id="OP_Abzug">
					<xsl:value-of select="Beleg/OPs/OP_Abzug_Ausblenden"/>
				</p>
				<p id="OP_Ausstand_Nachher_FW">
					<xsl:value-of select="Beleg/OPs/OP_Ausstand_Ausblenden_FW"/>
				</p>
				<p id="OP_Ausstand_Nachher_HW">
					<xsl:value-of select="Beleg/OPs/OP_Ausstand_Ausblenden_HW"/>
				</p>
				<p id="Kore_Ausblenden">
					<xsl:value-of select="Beleg/Korezeilen/Korezeilen_Ausblenden"/>
				</p>
				<p id="Kore_KoTr1">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr1_Ausblenden"/>
				</p>
				<p id="Kore_KoTr2">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr2_Ausblenden"/>
				</p>
				<p id="Kore_KoTr3">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr3_Ausblenden"/>
				</p>
				<p id="Kore_KoTr4">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr4_Ausblenden"/>
				</p>
				<p id="Kore_KoTr5">
					<xsl:value-of select="Beleg/Korezeilen/Kore_KoTr5_Ausblenden"/>
				</p>
				<p id="Kore_Menge">
					<xsl:value-of select="Beleg/Korezeilen/Kore_Menge_Ausblenden"/>
				</p>
				<p id="Anbu_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_Ausblenden"/>
				</p>
				<p id="Anbu_InvNr_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_InvNr_Ausblenden"/>
				</p>
				<p id="Anbu_Restwert_Ausblenden">
					<xsl:value-of select="Beleg/Anbuzeilen/Anbuzeilen_Restwert_Ausblenden"/>
				</p>
				<script language="javascript" type="text/javascript">	
					document.getElements = function(cl)
					{
						var retnode = [];
						var myclass = new RegExp('\\b'+cl+'\\b');
						var elem = this.getElementsByTagName('*');
						var i = 0;
						while( i != elem.length)
						{
							var classes = elem[i].className;
							if (myclass.test(classes)) retnode.push(elem[i]);
							i++;
						}
						return retnode;
					}						
					function Hide(e, p)
					{
						var ele = document.getElements('');
						var i = 0;
						while (i != ele.length)
						{
							if (ele[i].className == "Color")
							{
								var color = document.getElementById(ele[i].className).innerHTML;
								ele[i].style.color = color;
							}
							else
							{
								var status = document.getElementById(ele[i].className).innerHTML;
								ele[i].style.display = status;
							}
							i++;
						}
					}
				</script>
			</body>
		</html>
    </xsl:template>
</xsl:stylesheet>
