
---------------------------------------------------------------------------------------------------------------------
-- Muster fr die Prozedur fibu_stapel_proc, die von der Stapelprfung in der Fibu aufgerufen wird.
-- Dieses Skriptum ist nur per DBACCESS ausfhrbar!
--
---------------------------------------------------------------------------------------------------------------------
-- Was auch immer es bisher auf der DB gab, es verschwindet jetzt
CREATE PROCEDURE temp_stapel_drop_init();
	IF EXISTS(SELECT 1 FROM informix.sysprocedures
		WHERE procname='fibu_stapel_proc' AND owner=USER)
	THEN
		DROP PROCEDURE fibu_stapel_proc;
	END IF;
END PROCEDURE;

EXECUTE PROCEDURE temp_stapel_drop_init();

DROP PROCEDURE temp_stapel_drop_init;

BEGIN WORK;

---------------------------------------------------------------------------------------------------------------------
-- Die Prozedur fibu_stapel_proc mu in ihrer endgltigen Form diese Schnittstelle haben!
-- Die eigentliche Funktionalitt ist der Fibu vllig egal.
-- Folgend die Bedeutung der bergabeparameter:

-- iMandant			Mandantennummer
-- iStapelRefID		Stapelnummer
-- iStapelLfdNr		Laufende Nummer in dem Stapel

CREATE PROCEDURE fibu_stapel_proc (
	iMandant	INTEGER,
	iStapelRefID	INTEGER,
	iStapelLfdNr	INTEGER
);
-- 	INSERT INTO xy_tabelle (col1, col2, col3)
-- 	VALUES (iMandant, iStapelRefID, iStapelLfdNr);		
END PROCEDURE /* fibu_stapel_proc */
DOCUMENT 'Zustzliche Aktionen beim Prfen einer Buchung im Stapel'
;

-- Pauschales Ausfhrungsrecht: Einschrnkungen sind per Hand auszufhren
GRANT EXECUTE ON fibu_stapel_proc TO PUBLIC;

COMMIT WORK;
