#IF Oracle

CREATE OR REPLACE PACKAGE FIBU_TI_STAPEL_ID_pck AS 
c_protokoll_id fibu_stapel.c_protokoll_id%TYPE;
i_firm_refid fibu_stapel.i_firm_refid%TYPE;
i_stapel_refid fibu_stapel.i_stapel_refid%TYPE;
i_lfdnr fibu_stapel.i_lfdnr%TYPE;
END;
/

CREATE OR REPLACE TRIGGER FIBU_TI_STAPEL_ID 
	BEFORE INSERT ON fibu_stapel
	FOR EACH ROW
	DECLARE
		sProtokollID VARCHAR2(100);
	BEGIN
		IF :NEW.c_protokoll_id is NULL THEN
	                IF :NEW.si_zeilenr = 1 OR :NEW.si_zeilenr = 0 THEN
			               sProtokollID := :NEW.i_stapel_refid || '-' || :NEW.i_lfdnr || '-' || SYSDATE;
					
                  	FIBU_TI_STAPEL_ID_pck.c_protokoll_id := sProtokollID;
				          	FIBU_TI_STAPEL_ID_pck.i_firm_refid := :NEW.i_firm_refid;
					          FIBU_TI_STAPEL_ID_pck.i_stapel_refid :=:NEW.i_stapel_refid;
				          	FIBU_TI_STAPEL_ID_pck.i_lfdnr := :NEW.i_lfdnr;					
				          	:NEW.c_protokoll_id := sProtokollID;
					
           			ELSE
                       if FIBU_TI_STAPEL_ID_pck.c_protokoll_id IS NOT NULL  AND
                          FIBU_TI_STAPEL_ID_pck.i_firm_refid = :NEW.i_firm_refid  AND
					                FIBU_TI_STAPEL_ID_pck.i_stapel_refid =:NEW.i_stapel_refid AND
                          FIBU_TI_STAPEL_ID_pck.i_lfdnr = :NEW.i_lfdnr THEN
                               :NEW.c_protokoll_id := FIBU_TI_STAPEL_ID_pck.c_protokoll_id;
                       END IF;					   		
			         END IF;	
        ELSE
			UPDATE fibu_pt_stapel
			SET c_pt_aktion = 'U'
			WHERE i_firm_refid = :NEW.i_firm_refid
			AND c_protokoll_id = :NEW.c_protokoll_id;		 
		END IF;
	END fibu_ti_stapel_id;
	/

CREATE OR REPLACE TRIGGER FIBU_TU_STAPEL
	BEFORE UPDATE ON fibu_stapel
	FOR EACH ROW
	DECLARE
		v_username VARCHAR2(30);
	BEGIN
		IF :OLD.si_manipulation != :NEW.si_manipulation AND :NEW.si_manipulation >= 1 THEN
		BEGIN
			SELECT user INTO v_username FROM dual;
		
			INSERT INTO fibu_pt_stapel(i_firm_refid,
			i_stapel_refid,
			i_lfdnr,
			si_zeilenr,
			si_belegart,
			si_splitart,
			i_buchungskreis,
			d_beleg,
			d_valuta,
			c_urbelegid,
			c_op_beleg,
			c_rechnungid,
			c_buchtext,
			si_jahr,
			si_periode,
			i_sollkonto,
			i_db_kontosoll,
			c_kennungsoll,
			i_kennungsoll,
			si_skf_soll,
			i_habenkonto,
			i_db_kontohaben,
			c_kennunghaben,
			i_kennunghaben,
			si_skf_haben,
			dec_betrag,
			c_waehrung,
			dec_eigenbetrag,
			eur_betrag,
			i_gegenkonto,
			i_steuerart_refid,
			i_steuer_refid,
			i_steuerkonto,
			i_skontokonto,
			i_eg_gegenkonto,
			c_sollhabenkz,
			dec_steuer,
			dec_eigensteuer,
			eur_steuerbetrag,
			dec_steuerproz,
			c_zahlziel,
			d_zahlsperre_bis,
			i_auftragid,
			i_koart_refid,
			c_koart_schablone,
			si_pruef,
			c_bemerk,
			c_benutzer,
			c_kategorie,
			si_bankeinzug,
			c_bankkontonr,
			c_bankblz,
			c_bankname,
			c_iban,
			c_swift_code,
			i_bank_flags,
			si_bank_clearingart,
			c_bank_land,
			c_bank_text1,
			c_bank_text2,
			c_bank_text3,
			c_bank_text4,
			c_bank_text5,
			i_adress_refid,
			si_mahnung,
			c_sprache,
			si_anbu_art,
			c_anbu_inv_refid,
			si_anbu_unternr,
			c_anbu_kostid,
			dec_anbu_afa,
			i_anbu_afakto,
			dec_anbu_restwert,
			i_anbu_anlagenkto,
			i_einheit,
			dec_kurs,
			eur_kurs,
			i_anzahlkto,
			dec_anbu_ahk,
			dec_anbu_afaab,
			i_nnf_steuerkonto,
			i_nnf_skontokonto,
			i_zusatz,
			i_nnf_eg_konto,
			i_naf_konto ,
			dec_abzugsfaehig,
			c_absender,
			c_abs_bank,
			c_abs_blz,
			c_abs_knr,
			c_empfaenger,
			c_verwend,
			c_verwend2,
			c_verwend3,
			c_esr,
			si_kennung,
			i_st_input,
			i_verdichtet,
			i_intern,
			c_dms_docid,
			i_beleg_refid,
			i_buchschab_id,
			d_gueltig_bis,
			c_sepa_mandat,
			c_ustidnr,
			i_quelle_modul,
			c_quelle_maske,
			si_manipulation,
			dt_creation,
			c_pt_benutzer,
			c_pt_aktion,
			dt_pt_timestamp,
			c_protokoll_id)
			VALUES (:OLD.i_firm_refid,
			:OLD.i_stapel_refid,
			:OLD.i_lfdnr,
			:OLD.si_zeilenr,
			:OLD.si_belegart,
			:OLD.si_splitart,
			:OLD.i_buchungskreis,
			:OLD.d_beleg,
			:OLD.d_valuta,
			:OLD.c_urbelegid,
			:OLD.c_op_beleg,
			:OLD.c_rechnungid,
			:OLD.c_buchtext,
			:OLD.si_jahr,
			:OLD.si_periode,
			:OLD.i_sollkonto,
			:OLD.i_db_kontosoll,
			:OLD.c_kennungsoll,
			:OLD.i_kennungsoll,
			:OLD.si_skf_soll,
			:OLD.i_habenkonto,
			:OLD.i_db_kontohaben,
			:OLD.c_kennunghaben,
			:OLD.i_kennunghaben,
			:OLD.si_skf_haben,
			:OLD.dec_betrag,
			:OLD.c_waehrung,
			:OLD.dec_eigenbetrag,
			:OLD.eur_betrag,
			:OLD.i_gegenkonto,
			:OLD.i_steuerart_refid,
			:OLD.i_steuer_refid,
			:OLD.i_steuerkonto,
			:OLD.i_skontokonto,
			:OLD.i_eg_gegenkonto,
			:OLD.c_sollhabenkz,
			:OLD.dec_steuer,
			:OLD.dec_eigensteuer,
			:OLD.eur_steuerbetrag,
			:OLD.dec_steuerproz,
			:OLD.c_zahlziel,
			:OLD.d_zahlsperre_bis,
			:OLD.i_auftragid,
			:OLD.i_koart_refid,
			:OLD.c_koart_schablone,
			:OLD.si_pruef,
			:OLD.c_bemerk,
			:OLD.c_benutzer,
			:OLD.c_kategorie,
			:OLD.si_bankeinzug,
			:OLD.c_bankkontonr,
			:OLD.c_bankblz,
			:OLD.c_bankname,
			:OLD.c_iban,
			:OLD.c_swift_code,
			:OLD.i_bank_flags,
			:OLD.si_bank_clearingart,
			:OLD.c_bank_land,
			:OLD.c_bank_text1,
			:OLD.c_bank_text2,
			:OLD.c_bank_text3,
			:OLD.c_bank_text4,
			:OLD.c_bank_text5,
			:OLD.i_adress_refid,
			:OLD.si_mahnung,
			:OLD.c_sprache,
			:OLD.si_anbu_art,
			:OLD.c_anbu_inv_refid,
			:OLD.si_anbu_unternr,
			:OLD.c_anbu_kostid,
			:OLD.dec_anbu_afa,
			:OLD.i_anbu_afakto,
			:OLD.dec_anbu_restwert,
			:OLD.i_anbu_anlagenkto,
			:OLD.i_einheit,
			:OLD.dec_kurs,
			:OLD.eur_kurs,
			:OLD.i_anzahlkto,
			:OLD.dec_anbu_ahk,
			:OLD.dec_anbu_afaab,
			:OLD.i_nnf_steuerkonto,
			:OLD.i_nnf_skontokonto,
			:OLD.i_zusatz,
			:OLD.i_nnf_eg_konto,
			:OLD.i_naf_konto ,
			:OLD.dec_abzugsfaehig,
			:OLD.c_absender,
			:OLD.c_abs_bank,
			:OLD.c_abs_blz,
			:OLD.c_abs_knr,
			:OLD.c_empfaenger,
			:OLD.c_verwend,
			:OLD.c_verwend2,
			:OLD.c_verwend3,
			:OLD.c_esr,
			:OLD.si_kennung,
			:OLD.i_st_input,
			:OLD.i_verdichtet,
			:OLD.i_intern,
			:OLD.c_dms_docid,
			:OLD.i_beleg_refid,
			:OLD.i_buchschab_id,
			:OLD.d_gueltig_bis,
			:OLD.c_sepa_mandat,
			:OLD.c_ustidnr,
			:OLD.i_quelle_modul,
			:OLD.c_quelle_maske,
			:OLD.si_manipulation,
			:OLD.dt_creation,
			v_username,
			'U',
			SYSDATE,
			:OLD.c_protokoll_id);
		END;
		END IF;
	END fibu_tu_stapel;
	/

CREATE OR REPLACE TRIGGER FIBU_TD_STAPEL
	BEFORE DELETE ON fibu_stapel
	FOR EACH ROW
	DECLARE
		v_username VARCHAR2(30);
		user_aktion VARCHAR(2);
	BEGIN
		IF :OLD.i_beleg_refid is NULL THEN
	        	user_aktion := 'D';     
		ELSE
			user_aktion := 'C';
		END IF;
		
		SELECT user INTO v_username FROM dual;
		
		INSERT INTO fibu_pt_stapel(i_firm_refid,
			i_stapel_refid,
			i_lfdnr,
			si_zeilenr,
			si_belegart,
			si_splitart,
			i_buchungskreis,
			d_beleg,
			d_valuta,
			c_urbelegid,
			c_op_beleg,
			c_rechnungid,
			c_buchtext,
			si_jahr,
			si_periode,
			i_sollkonto,
			i_db_kontosoll,
			c_kennungsoll,
			i_kennungsoll,
			si_skf_soll,
			i_habenkonto,
			i_db_kontohaben,
			c_kennunghaben,
			i_kennunghaben,
			si_skf_haben,
			dec_betrag,
			c_waehrung,
			dec_eigenbetrag,
			eur_betrag,
			i_gegenkonto,
			i_steuerart_refid,
			i_steuer_refid,
			i_steuerkonto,
			i_skontokonto,
			i_eg_gegenkonto,
			c_sollhabenkz,
			dec_steuer,
			dec_eigensteuer,
			eur_steuerbetrag,
			dec_steuerproz,
			c_zahlziel,
			d_zahlsperre_bis,
			i_auftragid,
			i_koart_refid,
			c_koart_schablone,
			si_pruef,
			c_bemerk,
			c_benutzer,
			c_kategorie,
			si_bankeinzug,
			c_bankkontonr,
			c_bankblz,
			c_bankname,
			c_iban,
			c_swift_code,
			i_bank_flags,
			si_bank_clearingart,
			c_bank_land,
			c_bank_text1,
			c_bank_text2,
			c_bank_text3,
			c_bank_text4,
			c_bank_text5,
			i_adress_refid,
			si_mahnung,
			c_sprache,
			si_anbu_art,
			c_anbu_inv_refid,
			si_anbu_unternr,
			c_anbu_kostid,
			dec_anbu_afa,
			i_anbu_afakto,
			dec_anbu_restwert,
			i_anbu_anlagenkto,
			i_einheit,
			dec_kurs,
			eur_kurs,
			i_anzahlkto,
			dec_anbu_ahk,
			dec_anbu_afaab,
			i_nnf_steuerkonto,
			i_nnf_skontokonto,
			i_zusatz,
			i_nnf_eg_konto,
			i_naf_konto ,
			dec_abzugsfaehig,
			c_absender,
			c_abs_bank,
			c_abs_blz,
			c_abs_knr,
			c_empfaenger,
			c_verwend,
			c_verwend2,
			c_verwend3,
			c_esr,
			si_kennung,
			i_st_input,
			i_verdichtet,
			i_intern,
			c_dms_docid,
			i_beleg_refid,
			i_buchschab_id,
			d_gueltig_bis,
			c_sepa_mandat,
			c_ustidnr,
			i_quelle_modul,
			c_quelle_maske,
			si_manipulation,
			dt_creation,
			c_pt_benutzer,
			c_pt_aktion,
			dt_pt_timestamp,
			c_protokoll_id)
			VALUES (:OLD.i_firm_refid,
			:OLD.i_stapel_refid,
			:OLD.i_lfdnr,
			:OLD.si_zeilenr,
			:OLD.si_belegart,
			:OLD.si_splitart,
			:OLD.i_buchungskreis,
			:OLD.d_beleg,
			:OLD.d_valuta,
			:OLD.c_urbelegid,
			:OLD.c_op_beleg,
			:OLD.c_rechnungid,
			:OLD.c_buchtext,
			:OLD.si_jahr,
			:OLD.si_periode,
			:OLD.i_sollkonto,
			:OLD.i_db_kontosoll,
			:OLD.c_kennungsoll,
			:OLD.i_kennungsoll,
			:OLD.si_skf_soll,
			:OLD.i_habenkonto,
			:OLD.i_db_kontohaben,
			:OLD.c_kennunghaben,
			:OLD.i_kennunghaben,
			:OLD.si_skf_haben,
			:OLD.dec_betrag,
			:OLD.c_waehrung,
			:OLD.dec_eigenbetrag,
			:OLD.eur_betrag,
			:OLD.i_gegenkonto,
			:OLD.i_steuerart_refid,
			:OLD.i_steuer_refid,
			:OLD.i_steuerkonto,
			:OLD.i_skontokonto,
			:OLD.i_eg_gegenkonto,
			:OLD.c_sollhabenkz,
			:OLD.dec_steuer,
			:OLD.dec_eigensteuer,
			:OLD.eur_steuerbetrag,
			:OLD.dec_steuerproz,
			:OLD.c_zahlziel,
			:OLD.d_zahlsperre_bis,
			:OLD.i_auftragid,
			:OLD.i_koart_refid,
			:OLD.c_koart_schablone,
			:OLD.si_pruef,
			:OLD.c_bemerk,
			:OLD.c_benutzer,
			:OLD.c_kategorie,
			:OLD.si_bankeinzug,
			:OLD.c_bankkontonr,
			:OLD.c_bankblz,
			:OLD.c_bankname,
			:OLD.c_iban,
			:OLD.c_swift_code,
			:OLD.i_bank_flags,
			:OLD.si_bank_clearingart,
			:OLD.c_bank_land,
			:OLD.c_bank_text1,
			:OLD.c_bank_text2,
			:OLD.c_bank_text3,
			:OLD.c_bank_text4,
			:OLD.c_bank_text5,
			:OLD.i_adress_refid,
			:OLD.si_mahnung,
			:OLD.c_sprache,
			:OLD.si_anbu_art,
			:OLD.c_anbu_inv_refid,
			:OLD.si_anbu_unternr,
			:OLD.c_anbu_kostid,
			:OLD.dec_anbu_afa,
			:OLD.i_anbu_afakto,
			:OLD.dec_anbu_restwert,
			:OLD.i_anbu_anlagenkto,
			:OLD.i_einheit,
			:OLD.dec_kurs,
			:OLD.eur_kurs,
			:OLD.i_anzahlkto,
			:OLD.dec_anbu_ahk,
			:OLD.dec_anbu_afaab,
			:OLD.i_nnf_steuerkonto,
			:OLD.i_nnf_skontokonto,
			:OLD.i_zusatz,
			:OLD.i_nnf_eg_konto,
			:OLD.i_naf_konto ,
			:OLD.dec_abzugsfaehig,
			:OLD.c_absender,
			:OLD.c_abs_bank,
			:OLD.c_abs_blz,
			:OLD.c_abs_knr,
			:OLD.c_empfaenger,
			:OLD.c_verwend,
			:OLD.c_verwend2,
			:OLD.c_verwend3,
			:OLD.c_esr,
			:OLD.si_kennung,
			:OLD.i_st_input,
			:OLD.i_verdichtet,
			:OLD.i_intern,
			:OLD.c_dms_docid,
			:OLD.i_beleg_refid,
			:OLD.i_buchschab_id,
			:OLD.d_gueltig_bis,
			:OLD.c_sepa_mandat,
			:OLD.c_ustidnr,
			:OLD.i_quelle_modul,
			:OLD.c_quelle_maske,
			:OLD.si_manipulation,
			:OLD.dt_creation,
			v_username,
			user_aktion,
			SYSDATE,
			:OLD.c_protokoll_id);
		
	END fibu_td_stapel;
	/

#ELSIF SQLServer
IF EXISTS (SELECT 1 FROM sysobjects WHERE id=Object_ID(N'fibu_ti_stapel_id',N'TR') AND parent_obj=Object_ID(N'fibu_stapel','U'))
		DROP TRIGGER fibu_ti_stapel_id
	/
CREATE TRIGGER fibu_ti_stapel_id
ON fibu_stapel AFTER INSERT
AS
	SET NOCOUNT ON;
	DECLARE @sProtokollID VARCHAR(100),
		@FirmID INT,
		@StapelID INT,
		@LfdNr INT,
		@Zeile INT;
	SELECT 	@sProtokollID=i.c_protokoll_id,
		@FirmID=i.i_firm_refid,
		@StapelID=i.i_stapel_refid,
		@LfdNr=i.i_lfdnr,
		@Zeile=i.si_zeilenr
	FROM inserted i
	IF ((@sProtokollID IS NULL) OR (@sProtokollID = ''))
	BEGIN
		IF (@Zeile = 1 OR @Zeile = 0)
		BEGIN
			SELECT @sProtokollID = convert(VARCHAR,@StapelID) + '-' + convert(VARCHAR,@LfdNr) + '-' + convert(VARCHAR,getdate(),20);
		END
		ELSE
		BEGIN
			SELECT @sProtokollID=c_protokoll_id 
			FROM fibu_stapel
			WHERE i_firm_refid = @FirmID
			AND i_stapel_refid = @StapelID
			AND i_lfdnr = @LfdNr
			AND si_zeilenr = 1
		END
	END
	ELSE
	BEGIN
		UPDATE fibu_pt_stapel
		SET c_pt_aktion = 'U'
		WHERE i_firm_refid = @FirmID
		AND c_protokoll_id = @sProtokollID;
	END
	
	
	UPDATE fibu_stapel
	SET c_protokoll_id = @sProtokollID
	WHERE i_firm_refid = @FirmID
	AND i_stapel_refid = @StapelID
	AND i_lfdnr = @LfdNr
	
	UPDATE kr_stapel
	SET c_protokoll_id = @sProtokollID
	FROM inserted INNER JOIN kr_stapel On inserted.i_firm_refid = kr_stapel.i_firmid
	AND inserted.i_stapel_refid = kr_stapel.i_stapelid
	AND inserted.i_lfdnr = kr_stapel.si_stapel_lfdnr
	AND inserted.si_zeilenr = kr_stapel.si_stapel_zeile
/
	
	
IF EXISTS (SELECT 1 FROM sysobjects WHERE id=Object_ID(N'fibu_tu_stapel',N'TR') AND parent_obj=Object_ID(N'fibu_stapel','U'))
		DROP TRIGGER fibu_tu_stapel
	/
	
CREATE TRIGGER fibu_tu_stapel 
ON fibu_stapel FOR UPDATE
AS
	SET NOCOUNT ON;
	DECLARE @ManipulationOld int,
		@ManipulationNew int;
	
	SELECT @ManipulationOld=si_manipulation FROM DELETED
	SELECT @ManipulationNew=si_manipulation FROM INSERTED
	
	IF (@ManipulationOld != @ManipulationNew AND @ManipulationNew >= 1)
	BEGIN
		INSERT INTO fibu_pt_stapel(i_firm_refid,
					i_stapel_refid,
					i_lfdnr,
					si_zeilenr,
					si_belegart,
					si_splitart,
					i_buchungskreis,
					d_beleg,
					d_valuta,
					c_urbelegid,
					c_op_beleg,
					c_rechnungid,
					c_buchtext,
					si_jahr,
					si_periode,
					i_sollkonto,
					i_db_kontosoll,
					c_kennungsoll,
					i_kennungsoll,
					si_skf_soll,
					i_habenkonto,
					i_db_kontohaben,
					c_kennunghaben,
					i_kennunghaben,
					si_skf_haben,
					dec_betrag,
					c_waehrung,
					dec_eigenbetrag,
					eur_betrag,
					i_gegenkonto,
					i_steuerart_refid,
					i_steuer_refid,
					i_steuerkonto,
					i_skontokonto,
					i_eg_gegenkonto,
					c_sollhabenkz,
					dec_steuer,
					dec_eigensteuer,
					eur_steuerbetrag,
					dec_steuerproz,
					c_zahlziel,
					d_zahlsperre_bis,
					i_auftragid,
					i_koart_refid,
					c_koart_schablone,
					si_pruef,
					c_bemerk,
					c_benutzer,
					c_kategorie,
					si_bankeinzug,
					c_bankkontonr,
					c_bankblz,
					c_bankname,
					c_iban,
					c_swift_code,
					i_bank_flags,
					si_bank_clearingart,
					c_bank_land,
					c_bank_text1,
					c_bank_text2,
					c_bank_text3,
					c_bank_text4,
					c_bank_text5,
					i_adress_refid,
					si_mahnung,
					c_sprache,
					si_anbu_art,
					c_anbu_inv_refid,
					si_anbu_unternr,
					c_anbu_kostid,
					dec_anbu_afa,
					i_anbu_afakto,
					dec_anbu_restwert,
					i_anbu_anlagenkto,
					i_einheit,
					dec_kurs,
					eur_kurs,
					i_anzahlkto,
					dec_anbu_ahk,
					dec_anbu_afaab,
					i_nnf_steuerkonto,
					i_nnf_skontokonto,
					i_zusatz,
					i_nnf_eg_konto,
					i_naf_konto ,
					dec_abzugsfaehig,
					c_absender,
					c_abs_bank,
					c_abs_blz,
					c_abs_knr,
					c_empfaenger,
					c_verwend,
					c_verwend2,
					c_verwend3,
					c_esr,
					si_kennung,
					i_st_input,
					i_verdichtet,
					i_intern,
					c_dms_docid,
					i_beleg_refid,
					i_buchschab_id,
					d_gueltig_bis,
					c_sepa_mandat,
					c_ustidnr,
					i_quelle_modul,
					c_quelle_maske,
					si_manipulation,
					dt_creation,
					c_pt_benutzer,
					c_pt_aktion,
					dt_pt_timestamp,
					c_protokoll_id)
					SELECT i_firm_refid,
					i_stapel_refid,
					i_lfdnr,
					si_zeilenr,
					si_belegart,
					si_splitart,
					i_buchungskreis,
					d_beleg,
					d_valuta,
					c_urbelegid,
					c_op_beleg,
					c_rechnungid,
					c_buchtext,
					si_jahr,
					si_periode,
					i_sollkonto,
					i_db_kontosoll,
					c_kennungsoll,
					i_kennungsoll,
					si_skf_soll,
					i_habenkonto,
					i_db_kontohaben,
					c_kennunghaben,
					i_kennunghaben,
					si_skf_haben,
					dec_betrag,
					c_waehrung,
					dec_eigenbetrag,
					eur_betrag,
					i_gegenkonto,
					i_steuerart_refid,
					i_steuer_refid,
					i_steuerkonto,
					i_skontokonto,
					i_eg_gegenkonto,
					c_sollhabenkz,
					dec_steuer,
					dec_eigensteuer,
					eur_steuerbetrag,
					dec_steuerproz,
					c_zahlziel,
					d_zahlsperre_bis,
					i_auftragid,
					i_koart_refid,
					c_koart_schablone,
					si_pruef,
					c_bemerk,
					c_benutzer,
					c_kategorie,
					si_bankeinzug,
					c_bankkontonr,
					c_bankblz,
					c_bankname,
					c_iban,
					c_swift_code,
					i_bank_flags,
					si_bank_clearingart,
					c_bank_land,
					c_bank_text1,
					c_bank_text2,
					c_bank_text3,
					c_bank_text4,
					c_bank_text5,
					i_adress_refid,
					si_mahnung,
					c_sprache,
					si_anbu_art,
					c_anbu_inv_refid,
					si_anbu_unternr,
					c_anbu_kostid,
					dec_anbu_afa,
					i_anbu_afakto,
					dec_anbu_restwert,
					i_anbu_anlagenkto,
					i_einheit,
					dec_kurs,
					eur_kurs,
					i_anzahlkto,
					dec_anbu_ahk,
					dec_anbu_afaab,
					i_nnf_steuerkonto,
					i_nnf_skontokonto,
					i_zusatz,
					i_nnf_eg_konto,
					i_naf_konto ,
					dec_abzugsfaehig,
					c_absender,
					c_abs_bank,
					c_abs_blz,
					c_abs_knr,
					c_empfaenger,
					c_verwend,
					c_verwend2,
					c_verwend3,
					c_esr,
					si_kennung,
					i_st_input,
					i_verdichtet,
					i_intern,
					c_dms_docid,
					i_beleg_refid,
					i_buchschab_id,
					d_gueltig_bis,
					c_sepa_mandat,
					c_ustidnr,
					i_quelle_modul,
					c_quelle_maske,
					si_manipulation,
					dt_creation,
					USER,
					'U',
					CURRENT_TIMESTAMP,
					c_protokoll_id
					FROM deleted
	END
/

IF EXISTS (SELECT 1 FROM sysobjects WHERE id=Object_ID(N'fibu_td_stapel',N'TR') AND parent_obj=Object_ID(N'fibu_stapel','U'))
		DROP TRIGGER fibu_td_stapel
	/
	
CREATE TRIGGER fibu_td_stapel 
ON fibu_stapel FOR DELETE
AS
	SET NOCOUNT ON
	DECLARE @BelegRefID INT,
		@user_aktion VARCHAR(2),
		@sProtokollID VARCHAR(100),
		@FirmID INT
		
	SELECT 	@BelegRefID=d.i_beleg_refid,
		@sProtokollID=d.c_protokoll_id,
		@FirmID=d.i_firm_refid
	FROM deleted d
	
	IF (@BelegRefID > 0)
	BEGIN
		SELECT @user_aktion = 'V';
	END
	ELSE
	BEGIN
		SELECT @user_aktion = 'D'
	END
		
	INSERT INTO fibu_pt_stapel(i_firm_refid,
			i_stapel_refid,
			i_lfdnr,
			si_zeilenr,
			si_belegart,
			si_splitart,
			i_buchungskreis,
			d_beleg,
			d_valuta,
			c_urbelegid,
			c_op_beleg,
			c_rechnungid,
			c_buchtext,
			si_jahr,
			si_periode,
			i_sollkonto,
			i_db_kontosoll,
			c_kennungsoll,
			i_kennungsoll,
			si_skf_soll,
			i_habenkonto,
			i_db_kontohaben,
			c_kennunghaben,
			i_kennunghaben,
			si_skf_haben,
			dec_betrag,
			c_waehrung,
			dec_eigenbetrag,
			eur_betrag,
			i_gegenkonto,
			i_steuerart_refid,
			i_steuer_refid,
			i_steuerkonto,
			i_skontokonto,
			i_eg_gegenkonto,
			c_sollhabenkz,
			dec_steuer,
			dec_eigensteuer,
			eur_steuerbetrag,
			dec_steuerproz,
			c_zahlziel,
			d_zahlsperre_bis,
			i_auftragid,
			i_koart_refid,
			c_koart_schablone,
			si_pruef,
			c_bemerk,
			c_benutzer,
			c_kategorie,
			si_bankeinzug,
			c_bankkontonr,
			c_bankblz,
			c_bankname,
			c_iban,
			c_swift_code,
			i_bank_flags,
			si_bank_clearingart,
			c_bank_land,
			c_bank_text1,
			c_bank_text2,
			c_bank_text3,
			c_bank_text4,
			c_bank_text5,
			i_adress_refid,
			si_mahnung,
			c_sprache,
			si_anbu_art,
			c_anbu_inv_refid,
			si_anbu_unternr,
			c_anbu_kostid,
			dec_anbu_afa,
			i_anbu_afakto,
			dec_anbu_restwert,
			i_anbu_anlagenkto,
			i_einheit,
			dec_kurs,
			eur_kurs,
			i_anzahlkto,
			dec_anbu_ahk,
			dec_anbu_afaab,
			i_nnf_steuerkonto,
			i_nnf_skontokonto,
			i_zusatz,
			i_nnf_eg_konto,
			i_naf_konto ,
			dec_abzugsfaehig,
			c_absender,
			c_abs_bank,
			c_abs_blz,
			c_abs_knr,
			c_empfaenger,
			c_verwend,
			c_verwend2,
			c_verwend3,
			c_esr,
			si_kennung,
			i_st_input,
			i_verdichtet,
			i_intern,
			c_dms_docid,
			i_beleg_refid,
			i_buchschab_id,
			d_gueltig_bis,
			c_sepa_mandat,
			c_ustidnr,
			i_quelle_modul,
			c_quelle_maske,
			si_manipulation,
			dt_creation,
			c_pt_benutzer,
			c_pt_aktion,
			dt_pt_timestamp,
			c_protokoll_id)
		SELECT i_firm_refid,
			i_stapel_refid,
			i_lfdnr,
			si_zeilenr,
			si_belegart,
			si_splitart,
			i_buchungskreis,
			d_beleg,
			d_valuta,
			c_urbelegid,
			c_op_beleg,
			c_rechnungid,
			c_buchtext,
			si_jahr,
			si_periode,
			i_sollkonto,
			i_db_kontosoll,
			c_kennungsoll,
			i_kennungsoll,
			si_skf_soll,
			i_habenkonto,
			i_db_kontohaben,
			c_kennunghaben,
			i_kennunghaben,
			si_skf_haben,
			dec_betrag,
			c_waehrung,
			dec_eigenbetrag,
			eur_betrag,
			i_gegenkonto,
			i_steuerart_refid,
			i_steuer_refid,
			i_steuerkonto,
			i_skontokonto,
			i_eg_gegenkonto,
			c_sollhabenkz,
			dec_steuer,
			dec_eigensteuer,
			eur_steuerbetrag,
			dec_steuerproz,
			c_zahlziel,
			d_zahlsperre_bis,
			i_auftragid,
			i_koart_refid,
			c_koart_schablone,
			si_pruef,
			c_bemerk,
			c_benutzer,
			c_kategorie,
			si_bankeinzug,
			c_bankkontonr,
			c_bankblz,
			c_bankname,
			c_iban,
			c_swift_code,
			i_bank_flags,
			si_bank_clearingart,
			c_bank_land,
			c_bank_text1,
			c_bank_text2,
			c_bank_text3,
			c_bank_text4,
			c_bank_text5,
			i_adress_refid,
			si_mahnung,
			c_sprache,
			si_anbu_art,
			c_anbu_inv_refid,
			si_anbu_unternr,
			c_anbu_kostid,
			dec_anbu_afa,
			i_anbu_afakto,
			dec_anbu_restwert,
			i_anbu_anlagenkto,
			i_einheit,
			dec_kurs,
			eur_kurs,
			i_anzahlkto,
			dec_anbu_ahk,
			dec_anbu_afaab,
			i_nnf_steuerkonto,
			i_nnf_skontokonto,
			i_zusatz,
			i_nnf_eg_konto,
			i_naf_konto ,
			dec_abzugsfaehig,
			c_absender,
			c_abs_bank,
			c_abs_blz,
			c_abs_knr,
			c_empfaenger,
			c_verwend,
			c_verwend2,
			c_verwend3,
			c_esr,
			si_kennung,
			i_st_input,
			i_verdichtet,
			i_intern,
			c_dms_docid,
			i_beleg_refid,
			i_buchschab_id,
			d_gueltig_bis,
			c_sepa_mandat,
			c_ustidnr,
			i_quelle_modul,
			c_quelle_maske,
			si_manipulation,
			dt_creation,
			USER,
			@user_aktion,
			CURRENT_TIMESTAMP,
			c_protokoll_id
		FROM deleted
	
/
#ELSIF SQLBase
	#WHILE	SELECT name INTO :sInternalObjectName 
		FROM sysadm.systriggers
		WHERE creator=USER AND name IN('FIBU_TI_STAPEL_ID')
			AND tbsnum=(SELECT snum FROM sysadm.systables WHERE name='FIBU_STAPEL' AND creator=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#ENDLOOP
	
	CREATE TRIGGER fibu_ti_stapel_id
	BEFORE INSERT ON fibu_stapel
	(EXECUTE INLINE (i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, c_protokoll_id)
	PROCEDURE fsneuereintrag STATIC
	PARAMETERS
		NUMBER: nFirmRefID
		NUMBER: nStapelID
		NUMBER: nLfdNr
		NUMBER: nZeile
		RECEIVE STRING: rsProtokollID
	Actions
		IF rsProtokollID = ''
			IF nZeile = 0 OR nZeile = 1
				BEGIN
				CALL SqlImmediate( 'SELECT @STRING(:nStapelID,0) || ''-'' || @STRING(:nLfdNr,0) || ''-'' || @DATETOCHAR(SYSDATETIME, ''YYYY-MM-DD HH:MI:SS'') INTO :rsProtokollID FROM dual' )
				
				CALL SqlImmediate('UPDATE kr_stapel\ 
				SET c_protokoll_id = :rsProtokollID\
				WHERE i_firmid = :nFirmRefID\
				AND i_stapelid = :nStapelID\
				AND si_stapel_lfdnr = :nLfdNr\
				AND si_stapel_zeile = :nZeile' )
				END
			ELSE
				BEGIN
				CALL SqlImmediate('SELECT c_protokoll_id INTO :rsProtokollID\
				FROM fibu_stapel WHERE i_firm_refid=:nFirmRefID\
				AND i_stapel_refid=:nStapelID\
				AND i_lfdnr=:nLfdNr\
				AND si_zeilenr=1' )
									
				CALL SqlImmediate('UPDATE kr_stapel\ 
				SET c_protokoll_id = :rsProtokollID\
				WHERE i_firmid = :nFirmRefID\
				AND i_stapelid = :nStapelID\
				AND si_stapel_lfdnr = :nLfdNr\
				AND si_stapel_zeile = :nZeile' )
				END
		ELSE
			BEGIN
			CALL SqlImmediate('UPDATE fibu_pt_stapel\
			SET c_pt_aktion = ''U''\
			WHERE i_firm_refid = :nFirmRefID\
			AND c_protokoll_id = :rsProtokollID')
			END
	) FOR EACH ROW
	/
	
	#WHILE	SELECT name INTO :sInternalObjectName 
		FROM sysadm.systriggers
		WHERE creator=USER AND name IN('FIBU_TU_STAPEL')
			AND tbsnum=(SELECT snum FROM sysadm.systables WHERE name='FIBU_STAPEL' AND creator=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#ENDLOOP
	
	CREATE TRIGGER FIBU_TU_STAPEL
	AFTER UPDATE ON FIBU_STAPEL
	REFERENCING OLD AS ALT
	NEW AS NEU
	(EXECUTE INLINE(ALT.i_firm_refid, ALT.i_stapel_refid, ALT.i_lfdnr, ALT.si_zeilenr, ALT.si_belegart, ALT.si_splitart, ALT.i_buchungskreis, ALT.d_beleg, ALT.d_valuta, ALT.c_urbelegid, ALT.c_op_beleg, ALT.c_rechnungid, ALT.c_buchtext, ALT.si_jahr, ALT.si_periode, ALT.i_sollkonto, ALT.i_db_kontosoll, ALT.c_kennungsoll, ALT.i_kennungsoll, ALT.si_skf_soll, ALT.i_habenkonto, ALT.i_db_kontohaben, ALT.c_kennunghaben, ALT.i_kennunghaben, ALT.si_skf_haben, ALT.dec_betrag, ALT.c_waehrung, ALT.dec_eigenbetrag, ALT.eur_betrag, ALT.i_gegenkonto, ALT.i_steuerart_refid, ALT.i_steuer_refid, ALT.i_steuerkonto, ALT.i_skontokonto, ALT.i_eg_gegenkonto, ALT.c_sollhabenkz, ALT.dec_steuer, ALT.dec_eigensteuer, ALT.eur_steuerbetrag, ALT.dec_steuerproz, ALT.c_zahlziel, ALT.d_zahlsperre_bis, ALT.i_auftragid, ALT.i_koart_refid, ALT.c_koart_schablone, ALT.si_pruef, ALT.c_bemerk, ALT.c_benutzer, ALT.c_kategorie, ALT.si_bankeinzug, ALT.c_bankkontonr, ALT.c_bankblz, ALT.c_bankname, ALT.c_iban, ALT.c_swift_code, ALT.i_bank_flags, ALT.si_bank_clearingart, ALT.c_bank_land, ALT.c_bank_text1, ALT.c_bank_text2, ALT.c_bank_text3, ALT.c_bank_text4, ALT.c_bank_text5, ALT.i_adress_refid, ALT.si_mahnung, ALT.c_sprache, ALT.si_anbu_art, ALT.c_anbu_inv_refid, ALT.si_anbu_unternr, ALT.c_anbu_kostid, ALT.dec_anbu_afa, ALT.i_anbu_afakto, ALT.dec_anbu_restwert, ALT.i_anbu_anlagenkto, ALT.i_einheit, ALT.dec_kurs, ALT.eur_kurs, ALT.i_anzahlkto, ALT.dec_anbu_ahk, ALT.dec_anbu_afaab, ALT.i_nnf_steuerkonto, ALT.i_nnf_skontokonto, ALT.i_zusatz, ALT.i_nnf_eg_konto, ALT.i_naf_konto , ALT.dec_abzugsfaehig, ALT.c_absender, ALT.c_abs_bank, ALT.c_abs_blz, ALT.c_abs_knr, ALT.c_empfaenger, ALT.c_verwend, ALT.c_verwend2, ALT.c_verwend3, ALT.c_esr, ALT.si_kennung, ALT.i_st_input, ALT.i_verdichtet, ALT.i_intern, ALT.c_dms_docid, ALT.i_beleg_refid, ALT.i_buchschab_id, ALT.d_gueltig_bis, ALT.c_sepa_mandat, ALT.c_ustidnr, ALT.i_quelle_modul, ALT.c_quelle_maske, ALT.si_manipulation, NEU.si_manipulation, ALT.dt_creation, ALT.c_protokoll_id)
	PROCEDURE UPDSTAPEL STATIC
	PARAMETERS
		NUMBER: i_firm_refid
		NUMBER: i_stapel_refid
		NUMBER: i_lfdnr
		NUMBER: si_zeilenr
		NUMBER: si_belegart
		NUMBER: si_splitart
		NUMBER: i_buchungskreis
		DATE/TIME: d_beleg
		DATE/TIME: d_valuta
		STRING: c_urbelegid
		STRING: c_op_beleg
		STRING: c_rechnungid
		STRING: c_buchtext
		NUMBER: si_jahr
		NUMBER: si_periode
		NUMBER: i_sollkonto
		NUMBER: i_db_kontosoll
		STRING: c_kennungsoll
		NUMBER: i_kennungsoll
		NUMBER: si_skf_soll
		NUMBER: i_habenkonto
		NUMBER: i_db_kontohaben
		STRING: c_kennunghaben
		NUMBER: i_kennunghaben
		NUMBER: si_skf_haben
		NUMBER: dec_betrag
		STRING: c_waehrung
		NUMBER: dec_eigenbetrag
		NUMBER: eur_betrag
		NUMBER: i_gegenkonto
		NUMBER: i_steuerart_refid
		NUMBER: i_steuer_refid
		NUMBER: i_steuerkonto
		NUMBER: i_skontokonto
		NUMBER: i_eg_gegenkonto
		STRING: c_sollhabenkz
		NUMBER: dec_steuer
		NUMBER: dec_eigensteuer
		NUMBER: eur_steuerbetrag
		NUMBER: dec_steuerproz
		STRING: c_zahlziel
		DATE/TIME: d_zahlsperre_bis
		NUMBER: i_auftragid
		NUMBER: i_koart_refid
		STRING: c_koart_schablone
		NUMBER: si_pruef
		STRING: c_bemerk
		STRING: c_benutzer
		STRING: c_kategorie
		NUMBER: si_bankeinzug
		STRING: c_bankkontonr
		STRING: c_bankblz
		STRING: c_bankname
		STRING: c_iban
		STRING: c_swift_code
		NUMBER: i_bank_flags
		NUMBER: si_bank_clearingart
		STRING: c_bank_land
		STRING: c_bank_text1
		STRING: c_bank_text2
		STRING: c_bank_text3
		STRING: c_bank_text4
		STRING: c_bank_text5
		NUMBER: i_adress_refid
		NUMBER: si_mahnung
		STRING: c_sprache
		NUMBER: si_anbu_art
		STRING: c_anbu_inv_refid
		NUMBER: si_anbu_unternr
		STRING: c_anbu_kostid
		NUMBER: dec_anbu_afa
		NUMBER: i_anbu_afakto
		NUMBER: dec_anbu_restwert
		NUMBER: i_anbu_anlagenkto
		NUMBER: i_einheit
		NUMBER: dec_kurs
		NUMBER: eur_kurs
		NUMBER: i_anzahlkto
		NUMBER: dec_anbu_ahk
		NUMBER: dec_anbu_afaab
		NUMBER: i_nnf_steuerkonto
		NUMBER: i_nnf_skontokonto
		NUMBER: i_zusatz
		NUMBER: i_nnf_eg_konto
		NUMBER: i_naf_konto 
		NUMBER: dec_abzugsfaehig
		STRING: c_absender
		STRING: c_abs_bank
		STRING: c_abs_blz
		STRING: c_abs_knr
		STRING: c_empfaenger
		STRING: c_verwend
		STRING: c_verwend2
		STRING: c_verwend3
		STRING: c_esr
		NUMBER: si_kennung
		NUMBER: i_st_input
		NUMBER: i_verdichtet
		NUMBER: i_intern
		STRING: c_dms_docid
		NUMBER: i_beleg_refid
		NUMBER: i_buchschab_id
		DATE/TIME: d_gueltig_bis
		STRING: c_sepa_mandat
		STRING: c_ustidnr
		NUMBER: i_quelle_modul
		STRING: c_quelle_maske
		NUMBER: si_manipulation
		NUMBER: si_manipulation_neu
		DATE/TIME: dt_creation
		STRING: c_protokoll_id
	ACTIONS
		IF  si_manipulation != si_manipulation_neu
			CALL SQLIMMEDIATE('INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer, c_pt_aktion, dt_pt_timestamp, c_protokoll_id
			)
			VALUES(:i_firm_refid, :i_stapel_refid, :i_lfdnr, :si_zeilenr, :si_belegart, :si_splitart, :i_buchungskreis, :d_beleg, :d_valuta, :c_urbelegid, :c_op_beleg, :c_rechnungid, :c_buchtext, :si_jahr, :si_periode, :i_sollkonto, :i_db_kontosoll, :c_kennungsoll, :i_kennungsoll, :si_skf_soll, :i_habenkonto, :i_db_kontohaben, :c_kennunghaben, :i_kennunghaben, :si_skf_haben, :dec_betrag, :c_waehrung, :dec_eigenbetrag, :eur_betrag, :i_gegenkonto, :i_steuerart_refid, :i_steuer_refid, :i_steuerkonto, :i_skontokonto, :i_eg_gegenkonto, :c_sollhabenkz, :dec_steuer, :dec_eigensteuer, :eur_steuerbetrag, :dec_steuerproz, :c_zahlziel, :d_zahlsperre_bis, :i_auftragid, :i_koart_refid, :c_koart_schablone, :si_pruef, :c_bemerk, :c_benutzer, :c_kategorie, :si_bankeinzug, :c_bankkontonr, :c_bankblz, :c_bankname, :c_iban, :c_swift_code, :i_bank_flags, :si_bank_clearingart, :c_bank_land, :c_bank_text1, :c_bank_text2, :c_bank_text3, :c_bank_text4, :c_bank_text5, :i_adress_refid, :si_mahnung, :c_sprache, :si_anbu_art, :c_anbu_inv_refid, :si_anbu_unternr, :c_anbu_kostid, :dec_anbu_afa, :i_anbu_afakto, :dec_anbu_restwert, :i_anbu_anlagenkto, :i_einheit, :dec_kurs, :eur_kurs, :i_anzahlkto, :dec_anbu_ahk, :dec_anbu_afaab, :i_nnf_steuerkonto, :i_nnf_skontokonto, :i_zusatz, :i_nnf_eg_konto, :i_naf_konto , :dec_abzugsfaehig, :c_absender, :c_abs_bank, :c_abs_blz, :c_abs_knr, :c_empfaenger, :c_verwend, :c_verwend2, :c_verwend3, :c_esr, :si_kennung, :i_st_input, :i_verdichtet, :i_intern, :c_dms_docid, :i_beleg_refid, :i_buchschab_id, :d_gueltig_bis, :c_sepa_mandat, :c_ustidnr, :i_quelle_modul, :c_quelle_maske, :si_manipulation, :dt_creation, USER, ''U'', SYSDATETIME, :c_protokoll_id
			)')
	)
	FOR EACH ROW
	/
	
	#WHILE	SELECT name INTO :sInternalObjectName 
		FROM sysadm.systriggers
		WHERE creator=USER AND name IN('FIBU_TD_STAPEL')
			AND tbsnum=(SELECT snum FROM sysadm.systables WHERE name='FIBU_STAPEL' AND creator=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#ENDLOOP
	
	CREATE TRIGGER FIBU_TD_STAPEL
	BEFORE DELETE ON FIBU_STAPEL
	(EXECUTE INLINE(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_protokoll_id)
	PROCEDURE DELSTAPEL STATIC
	PARAMETERS
		NUMBER: i_firm_refid
		NUMBER: i_stapel_refid
		NUMBER: i_lfdnr
		NUMBER: si_zeilenr
		NUMBER: si_belegart
		NUMBER: si_splitart
		NUMBER: i_buchungskreis
		DATE/TIME: d_beleg
		DATE/TIME: d_valuta
		STRING: c_urbelegid
		STRING: c_op_beleg
		STRING: c_rechnungid
		STRING: c_buchtext
		NUMBER: si_jahr
		NUMBER: si_periode
		NUMBER: i_sollkonto
		NUMBER: i_db_kontosoll
		STRING: c_kennungsoll
		NUMBER: i_kennungsoll
		NUMBER: si_skf_soll
		NUMBER: i_habenkonto
		NUMBER: i_db_kontohaben
		STRING: c_kennunghaben
		NUMBER: i_kennunghaben
		NUMBER: si_skf_haben
		NUMBER: dec_betrag
		STRING: c_waehrung
		NUMBER: dec_eigenbetrag
		NUMBER: eur_betrag
		NUMBER: i_gegenkonto
		NUMBER: i_steuerart_refid
		NUMBER: i_steuer_refid
		NUMBER: i_steuerkonto
		NUMBER: i_skontokonto
		NUMBER: i_eg_gegenkonto
		STRING: c_sollhabenkz
		NUMBER: dec_steuer
		NUMBER: dec_eigensteuer
		NUMBER: eur_steuerbetrag
		NUMBER: dec_steuerproz
		STRING: c_zahlziel
		DATE/TIME: d_zahlsperre_bis
		NUMBER: i_auftragid
		NUMBER: i_koart_refid
		STRING: c_koart_schablone
		NUMBER: si_pruef
		STRING: c_bemerk
		STRING: c_benutzer
		STRING: c_kategorie
		NUMBER: si_bankeinzug
		STRING: c_bankkontonr
		STRING: c_bankblz
		STRING: c_bankname
		STRING: c_iban
		STRING: c_swift_code
		NUMBER: i_bank_flags
		NUMBER: si_bank_clearingart
		STRING: c_bank_land
		STRING: c_bank_text1
		STRING: c_bank_text2
		STRING: c_bank_text3
		STRING: c_bank_text4
		STRING: c_bank_text5
		NUMBER: i_adress_refid
		NUMBER: si_mahnung
		STRING: c_sprache
		NUMBER: si_anbu_art
		STRING: c_anbu_inv_refid
		NUMBER: si_anbu_unternr
		STRING: c_anbu_kostid
		NUMBER: dec_anbu_afa
		NUMBER: i_anbu_afakto
		NUMBER: dec_anbu_restwert
		NUMBER: i_anbu_anlagenkto
		NUMBER: i_einheit
		NUMBER: dec_kurs
		NUMBER: eur_kurs
		NUMBER: i_anzahlkto
		NUMBER: dec_anbu_ahk
		NUMBER: dec_anbu_afaab
		NUMBER: i_nnf_steuerkonto
		NUMBER: i_nnf_skontokonto
		NUMBER: i_zusatz
		NUMBER: i_nnf_eg_konto
		NUMBER: i_naf_konto 
		NUMBER: dec_abzugsfaehig
		STRING: c_absender
		STRING: c_abs_bank
		STRING: c_abs_blz
		STRING: c_abs_knr
		STRING: c_empfaenger
		STRING: c_verwend
		STRING: c_verwend2
		STRING: c_verwend3
		STRING: c_esr
		NUMBER: si_kennung
		NUMBER: i_st_input
		NUMBER: i_verdichtet
		NUMBER: i_intern
		STRING: c_dms_docid
		NUMBER: i_beleg_refid
		NUMBER: i_buchschab_id
		DATE/TIME: d_gueltig_bis
		STRING: c_sepa_mandat
		STRING: c_ustidnr
		NUMBER: i_quelle_modul
		STRING: c_quelle_maske
		NUMBER: si_manipulation
		DATE/TIME: dt_creation
		STRING: c_protokoll_id
	LOCAL VARIABLES
		NUMBER: count
	ACTIONS
		IF i_beleg_refid > 0
			CALL SQLIMMEDIATE('INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer, c_pt_aktion, dt_pt_timestamp, c_protokoll_id)
				VALUES(:i_firm_refid, :i_stapel_refid, :i_lfdnr, :si_zeilenr, :si_belegart, :si_splitart, :i_buchungskreis, :d_beleg, :d_valuta, :c_urbelegid, :c_op_beleg, :c_rechnungid, :c_buchtext, :si_jahr, :si_periode, :i_sollkonto, :i_db_kontosoll, :c_kennungsoll, :i_kennungsoll, :si_skf_soll, :i_habenkonto, :i_db_kontohaben, :c_kennunghaben, :i_kennunghaben, :si_skf_haben, :dec_betrag, :c_waehrung, :dec_eigenbetrag, :eur_betrag, :i_gegenkonto, :i_steuerart_refid, :i_steuer_refid, :i_steuerkonto, :i_skontokonto, :i_eg_gegenkonto, :c_sollhabenkz, :dec_steuer, :dec_eigensteuer, :eur_steuerbetrag, :dec_steuerproz, :c_zahlziel, :d_zahlsperre_bis, :i_auftragid, :i_koart_refid, :c_koart_schablone, :si_pruef, :c_bemerk, :c_benutzer, :c_kategorie, :si_bankeinzug, :c_bankkontonr, :c_bankblz, :c_bankname, :c_iban, :c_swift_code, :i_bank_flags, :si_bank_clearingart, :c_bank_land, :c_bank_text1, :c_bank_text2, :c_bank_text3, :c_bank_text4, :c_bank_text5, :i_adress_refid, :si_mahnung, :c_sprache, :si_anbu_art, :c_anbu_inv_refid, :si_anbu_unternr, :c_anbu_kostid, :dec_anbu_afa, :i_anbu_afakto, :dec_anbu_restwert, :i_anbu_anlagenkto, :i_einheit, :dec_kurs, :eur_kurs, :i_anzahlkto, :dec_anbu_ahk, :dec_anbu_afaab, :i_nnf_steuerkonto, :i_nnf_skontokonto, :i_zusatz, :i_nnf_eg_konto, :i_naf_konto , :dec_abzugsfaehig, :c_absender, :c_abs_bank, :c_abs_blz, :c_abs_knr, :c_empfaenger, :c_verwend, :c_verwend2, :c_verwend3, :c_esr, :si_kennung, :i_st_input, :i_verdichtet, :i_intern, :c_dms_docid, :i_beleg_refid, :i_buchschab_id, :d_gueltig_bis, :c_sepa_mandat, :c_ustidnr, :i_quelle_modul, :c_quelle_maske, :si_manipulation, :dt_creation, USER, ''V'', SYSDATETIME, :c_protokoll_id)')
		ELSE
			CALL SQLIMMEDIATE('INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer, c_pt_aktion, dt_pt_timestamp, c_protokoll_id)
				VALUES(:i_firm_refid, :i_stapel_refid, :i_lfdnr, :si_zeilenr, :si_belegart, :si_splitart, :i_buchungskreis, :d_beleg, :d_valuta, :c_urbelegid, :c_op_beleg, :c_rechnungid, :c_buchtext, :si_jahr, :si_periode, :i_sollkonto, :i_db_kontosoll, :c_kennungsoll, :i_kennungsoll, :si_skf_soll, :i_habenkonto, :i_db_kontohaben, :c_kennunghaben, :i_kennunghaben, :si_skf_haben, :dec_betrag, :c_waehrung, :dec_eigenbetrag, :eur_betrag, :i_gegenkonto, :i_steuerart_refid, :i_steuer_refid, :i_steuerkonto, :i_skontokonto, :i_eg_gegenkonto, :c_sollhabenkz, :dec_steuer, :dec_eigensteuer, :eur_steuerbetrag, :dec_steuerproz, :c_zahlziel, :d_zahlsperre_bis, :i_auftragid, :i_koart_refid, :c_koart_schablone, :si_pruef, :c_bemerk, :c_benutzer, :c_kategorie, :si_bankeinzug, :c_bankkontonr, :c_bankblz, :c_bankname, :c_iban, :c_swift_code, :i_bank_flags, :si_bank_clearingart, :c_bank_land, :c_bank_text1, :c_bank_text2, :c_bank_text3, :c_bank_text4, :c_bank_text5, :i_adress_refid, :si_mahnung, :c_sprache, :si_anbu_art, :c_anbu_inv_refid, :si_anbu_unternr, :c_anbu_kostid, :dec_anbu_afa, :i_anbu_afakto, :dec_anbu_restwert, :i_anbu_anlagenkto, :i_einheit, :dec_kurs, :eur_kurs, :i_anzahlkto, :dec_anbu_ahk, :dec_anbu_afaab, :i_nnf_steuerkonto, :i_nnf_skontokonto, :i_zusatz, :i_nnf_eg_konto, :i_naf_konto , :dec_abzugsfaehig, :c_absender, :c_abs_bank, :c_abs_blz, :c_abs_knr, :c_empfaenger, :c_verwend, :c_verwend2, :c_verwend3, :c_esr, :si_kennung, :i_st_input, :i_verdichtet, :i_intern, :c_dms_docid, :i_beleg_refid, :i_buchschab_id, :d_gueltig_bis, :c_sepa_mandat, :c_ustidnr, :i_quelle_modul, :c_quelle_maske, :si_manipulation, :dt_creation, USER, ''D'', SYSDATETIME, :c_protokoll_id)')
	)
	FOR EACH ROW
	/
	
#ELSE IF INFORMIX11
	#WHILE	SELECT trigname INTO :sInternalObjectName
		FROM informix.systriggers
		WHERE trigname IN ('fibu_ti_stapel_id') AND owner=USER
			AND tabid=(SELECT tabid FROM informix.systables WHERE tabname='fibu_stapel' AND owner=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#END LOOP
	#WHILE	SELECT 1 FROM informix.sysprocedures
		WHERE procname='generatestapelprotokollid' AND owner=USER
	#LOOP
		DROP PROCEDURE generatestapelprotokollid
		/
	#ENDLOOP

	CREATE PROCEDURE generatestapelprotokollid()
	REFERENCING NEW AS neu FOR fibu_stapel;
		DEFINE sProtokollID VARCHAR(100);
		IF neu.c_protokoll_id = '' OR neu.c_protokoll_id IS NULL THEN
			IF neu.si_zeilenr=0 THEN
				LET sProtokollID=CAST(neu.i_stapel_refid AS VARCHAR(30)) || '-' || CAST(neu.i_lfdnr AS VARCHAR(30)) || '-' || TO_CHAR(CURRENT, '%Y-%m-%d %H:%M:%S');
			ELIF neu.si_zeilenr=1 THEN
				LET sProtokollID=CAST(neu.i_stapel_refid AS VARCHAR(30)) || '-' || CAST(neu.i_lfdnr AS VARCHAR(30)) || '-' || TO_CHAR(CURRENT, '%Y-%m-%d %H:%M:%S');
			ELSE
				SELECT c_protokoll_id 
				INTO sProtokollID
				FROM fibu_stapel
				WHERE i_firm_refid = neu.i_firm_refid
				AND i_stapel_refid = neu.i_stapel_refid
				AND i_lfdnr = neu.i_lfdnr
				AND si_zeilenr = 1;
			END IF
		
			UPDATE kr_stapel
			SET c_protokoll_id = sProtokollID
			WHERE i_firmid = neu.i_firm_refid
			AND i_stapelid = neu.i_stapel_refid
			AND si_stapel_lfdnr = neu.i_lfdnr
			AND si_stapel_zeile = neu.si_zeilenr;
		
			LET neu.c_protokoll_id = sProtokollID;
		ELSE
			UPDATE fibu_pt_stapel
			SET c_pt_aktion = 'U'
			WHERE i_firm_refid = neu.i_firm_refid
			AND c_protokoll_id = neu.c_protokoll_id;
		END IF
	END PROCEDURE;
	/
	
	CREATE TRIGGER fibu_ti_stapel_id
		INSERT ON fibu_stapel
		REFERENCING NEW AS neu
		FOR EACH ROW
			(
			EXECUTE PROCEDURE generatestapelprotokollid() with trigger references
			);
	/
	

	#WHILE	SELECT trigname INTO :sInternalObjectName
		FROM informix.systriggers
		WHERE trigname IN ('fibu_tu_stapel') AND owner=USER
			AND tabid=(SELECT tabid FROM informix.systables WHERE tabname='fibu_stapel' AND owner=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#END LOOP
	
	CREATE TRIGGER fibu_tu_stapel
	UPDATE ON fibu_stapel
	REFERENCING old AS ALT new AS NEU
	FOR EACH ROW WHEN (ALT.si_manipulation != NEU.si_manipulation)
	(
		INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer,c_pt_aktion,dt_pt_timestamp, c_protokoll_id)
		VALUES(ALT.i_firm_refid, ALT.i_stapel_refid, ALT.i_lfdnr, ALT.si_zeilenr, ALT.si_belegart, ALT.si_splitart, ALT.i_buchungskreis, ALT.d_beleg, ALT.d_valuta, ALT.c_urbelegid, ALT.c_op_beleg, ALT.c_rechnungid, ALT.c_buchtext, ALT.si_jahr, ALT.si_periode, ALT.i_sollkonto, ALT.i_db_kontosoll, ALT.c_kennungsoll, ALT.i_kennungsoll, ALT.si_skf_soll, ALT.i_habenkonto, ALT.i_db_kontohaben, ALT.c_kennunghaben, ALT.i_kennunghaben, ALT.si_skf_haben, ALT.dec_betrag, ALT.c_waehrung, ALT.dec_eigenbetrag, ALT.eur_betrag, ALT.i_gegenkonto, ALT.i_steuerart_refid, ALT.i_steuer_refid, ALT.i_steuerkonto, ALT.i_skontokonto, ALT.i_eg_gegenkonto, ALT.c_sollhabenkz, ALT.dec_steuer, ALT.dec_eigensteuer, ALT.eur_steuerbetrag, ALT.dec_steuerproz, ALT.c_zahlziel, ALT.d_zahlsperre_bis, ALT.i_auftragid, ALT.i_koart_refid, ALT.c_koart_schablone, ALT.si_pruef, ALT.c_bemerk, ALT.c_benutzer, ALT.c_kategorie, ALT.si_bankeinzug, ALT.c_bankkontonr, ALT.c_bankblz, ALT.c_bankname, ALT.c_iban, ALT.c_swift_code, ALT.i_bank_flags, ALT.si_bank_clearingart, ALT.c_bank_land, ALT.c_bank_text1, ALT.c_bank_text2, ALT.c_bank_text3, ALT.c_bank_text4, ALT.c_bank_text5, ALT.i_adress_refid, ALT.si_mahnung, ALT.c_sprache, ALT.si_anbu_art, ALT.c_anbu_inv_refid, ALT.si_anbu_unternr, ALT.c_anbu_kostid, ALT.dec_anbu_afa, ALT.i_anbu_afakto, ALT.dec_anbu_restwert, ALT.i_anbu_anlagenkto, ALT.i_einheit, ALT.dec_kurs, ALT.eur_kurs, ALT.i_anzahlkto, ALT.dec_anbu_ahk, ALT.dec_anbu_afaab, ALT.i_nnf_steuerkonto, ALT.i_nnf_skontokonto, ALT.i_zusatz, ALT.i_nnf_eg_konto, ALT.i_naf_konto , ALT.dec_abzugsfaehig, ALT.c_absender, ALT.c_abs_bank, ALT.c_abs_blz, ALT.c_abs_knr, ALT.c_empfaenger, ALT.c_verwend, ALT.c_verwend2, ALT.c_verwend3, ALT.c_esr, ALT.si_kennung, ALT.i_st_input, ALT.i_verdichtet, ALT.i_intern, ALT.c_dms_docid, ALT.i_beleg_refid, ALT.i_buchschab_id, ALT.d_gueltig_bis, ALT.c_sepa_mandat, ALT.c_ustidnr, ALT.i_quelle_modul, ALT.c_quelle_maske, ALT.si_manipulation, ALT.dt_creation, USER ,'U' ,CURRENT year to fraction(3), ALT.c_protokoll_id)
	);
	/
	
	#WHILE	SELECT trigname INTO :sInternalObjectName
		FROM informix.systriggers
		WHERE trigname IN ('fibu_td_stapel') AND owner=USER
			AND tabid=(SELECT tabid FROM informix.systables WHERE tabname='fibu_stapel' AND owner=USER)
	#LOOP
		DROP TRIGGER {InternalObjectName}
		/
	#END LOOP
	
	CREATE TRIGGER fibu_td_stapel
	DELETE ON fibu_stapel
	REFERENCING old AS ALT
	FOR EACH ROW
	WHEN ( ALT.i_beleg_refid > 0)
	(
		INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer,c_pt_aktion,dt_pt_timestamp, c_protokoll_id)
		VALUES(ALT.i_firm_refid, ALT.i_stapel_refid, ALT.i_lfdnr, ALT.si_zeilenr, ALT.si_belegart, ALT.si_splitart, ALT.i_buchungskreis, ALT.d_beleg, ALT.d_valuta, ALT.c_urbelegid, ALT.c_op_beleg, ALT.c_rechnungid, ALT.c_buchtext, ALT.si_jahr, ALT.si_periode, ALT.i_sollkonto, ALT.i_db_kontosoll, ALT.c_kennungsoll, ALT.i_kennungsoll, ALT.si_skf_soll, ALT.i_habenkonto, ALT.i_db_kontohaben, ALT.c_kennunghaben, ALT.i_kennunghaben, ALT.si_skf_haben, ALT.dec_betrag, ALT.c_waehrung, ALT.dec_eigenbetrag, ALT.eur_betrag, ALT.i_gegenkonto, ALT.i_steuerart_refid, ALT.i_steuer_refid, ALT.i_steuerkonto, ALT.i_skontokonto, ALT.i_eg_gegenkonto, ALT.c_sollhabenkz, ALT.dec_steuer, ALT.dec_eigensteuer, ALT.eur_steuerbetrag, ALT.dec_steuerproz, ALT.c_zahlziel, ALT.d_zahlsperre_bis, ALT.i_auftragid, ALT.i_koart_refid, ALT.c_koart_schablone, ALT.si_pruef, ALT.c_bemerk, ALT.c_benutzer, ALT.c_kategorie, ALT.si_bankeinzug, ALT.c_bankkontonr, ALT.c_bankblz, ALT.c_bankname, ALT.c_iban, ALT.c_swift_code, ALT.i_bank_flags, ALT.si_bank_clearingart, ALT.c_bank_land, ALT.c_bank_text1, ALT.c_bank_text2, ALT.c_bank_text3, ALT.c_bank_text4, ALT.c_bank_text5, ALT.i_adress_refid, ALT.si_mahnung, ALT.c_sprache, ALT.si_anbu_art, ALT.c_anbu_inv_refid, ALT.si_anbu_unternr, ALT.c_anbu_kostid, ALT.dec_anbu_afa, ALT.i_anbu_afakto, ALT.dec_anbu_restwert, ALT.i_anbu_anlagenkto, ALT.i_einheit, ALT.dec_kurs, ALT.eur_kurs, ALT.i_anzahlkto, ALT.dec_anbu_ahk, ALT.dec_anbu_afaab, ALT.i_nnf_steuerkonto, ALT.i_nnf_skontokonto, ALT.i_zusatz, ALT.i_nnf_eg_konto, ALT.i_naf_konto , ALT.dec_abzugsfaehig, ALT.c_absender, ALT.c_abs_bank, ALT.c_abs_blz, ALT.c_abs_knr, ALT.c_empfaenger, ALT.c_verwend, ALT.c_verwend2, ALT.c_verwend3, ALT.c_esr, ALT.si_kennung, ALT.i_st_input, ALT.i_verdichtet, ALT.i_intern, ALT.c_dms_docid, ALT.i_beleg_refid, ALT.i_buchschab_id, ALT.d_gueltig_bis, ALT.c_sepa_mandat, ALT.c_ustidnr, ALT.i_quelle_modul, ALT.c_quelle_maske, ALT.si_manipulation, ALT.dt_creation, USER ,'V' ,CURRENT year to fraction(3), ALT.c_protokoll_id)
	),
	WHEN ( ALT.i_beleg_refid IS NULL)
	(
		INSERT INTO fibu_pt_stapel(i_firm_refid, i_stapel_refid, i_lfdnr, si_zeilenr, si_belegart, si_splitart, i_buchungskreis, d_beleg, d_valuta, c_urbelegid, c_op_beleg, c_rechnungid, c_buchtext, si_jahr, si_periode, i_sollkonto, i_db_kontosoll, c_kennungsoll, i_kennungsoll, si_skf_soll, i_habenkonto, i_db_kontohaben, c_kennunghaben, i_kennunghaben, si_skf_haben, dec_betrag, c_waehrung, dec_eigenbetrag, eur_betrag, i_gegenkonto, i_steuerart_refid, i_steuer_refid, i_steuerkonto, i_skontokonto, i_eg_gegenkonto, c_sollhabenkz, dec_steuer, dec_eigensteuer, eur_steuerbetrag, dec_steuerproz, c_zahlziel, d_zahlsperre_bis, i_auftragid, i_koart_refid, c_koart_schablone, si_pruef, c_bemerk, c_benutzer, c_kategorie, si_bankeinzug, c_bankkontonr, c_bankblz, c_bankname, c_iban, c_swift_code, i_bank_flags, si_bank_clearingart, c_bank_land, c_bank_text1, c_bank_text2, c_bank_text3, c_bank_text4, c_bank_text5, i_adress_refid, si_mahnung, c_sprache, si_anbu_art, c_anbu_inv_refid, si_anbu_unternr, c_anbu_kostid, dec_anbu_afa, i_anbu_afakto, dec_anbu_restwert, i_anbu_anlagenkto, i_einheit, dec_kurs, eur_kurs, i_anzahlkto, dec_anbu_ahk, dec_anbu_afaab, i_nnf_steuerkonto, i_nnf_skontokonto, i_zusatz, i_nnf_eg_konto, i_naf_konto , dec_abzugsfaehig, c_absender, c_abs_bank, c_abs_blz, c_abs_knr, c_empfaenger, c_verwend, c_verwend2, c_verwend3, c_esr, si_kennung, i_st_input, i_verdichtet, i_intern, c_dms_docid, i_beleg_refid, i_buchschab_id, d_gueltig_bis, c_sepa_mandat, c_ustidnr, i_quelle_modul, c_quelle_maske, si_manipulation, dt_creation, c_pt_benutzer,c_pt_aktion,dt_pt_timestamp, c_protokoll_id)
		VALUES(ALT.i_firm_refid, ALT.i_stapel_refid, ALT.i_lfdnr, ALT.si_zeilenr, ALT.si_belegart, ALT.si_splitart, ALT.i_buchungskreis, ALT.d_beleg, ALT.d_valuta, ALT.c_urbelegid, ALT.c_op_beleg, ALT.c_rechnungid, ALT.c_buchtext, ALT.si_jahr, ALT.si_periode, ALT.i_sollkonto, ALT.i_db_kontosoll, ALT.c_kennungsoll, ALT.i_kennungsoll, ALT.si_skf_soll, ALT.i_habenkonto, ALT.i_db_kontohaben, ALT.c_kennunghaben, ALT.i_kennunghaben, ALT.si_skf_haben, ALT.dec_betrag, ALT.c_waehrung, ALT.dec_eigenbetrag, ALT.eur_betrag, ALT.i_gegenkonto, ALT.i_steuerart_refid, ALT.i_steuer_refid, ALT.i_steuerkonto, ALT.i_skontokonto, ALT.i_eg_gegenkonto, ALT.c_sollhabenkz, ALT.dec_steuer, ALT.dec_eigensteuer, ALT.eur_steuerbetrag, ALT.dec_steuerproz, ALT.c_zahlziel, ALT.d_zahlsperre_bis, ALT.i_auftragid, ALT.i_koart_refid, ALT.c_koart_schablone, ALT.si_pruef, ALT.c_bemerk, ALT.c_benutzer, ALT.c_kategorie, ALT.si_bankeinzug, ALT.c_bankkontonr, ALT.c_bankblz, ALT.c_bankname, ALT.c_iban, ALT.c_swift_code, ALT.i_bank_flags, ALT.si_bank_clearingart, ALT.c_bank_land, ALT.c_bank_text1, ALT.c_bank_text2, ALT.c_bank_text3, ALT.c_bank_text4, ALT.c_bank_text5, ALT.i_adress_refid, ALT.si_mahnung, ALT.c_sprache, ALT.si_anbu_art, ALT.c_anbu_inv_refid, ALT.si_anbu_unternr, ALT.c_anbu_kostid, ALT.dec_anbu_afa, ALT.i_anbu_afakto, ALT.dec_anbu_restwert, ALT.i_anbu_anlagenkto, ALT.i_einheit, ALT.dec_kurs, ALT.eur_kurs, ALT.i_anzahlkto, ALT.dec_anbu_ahk, ALT.dec_anbu_afaab, ALT.i_nnf_steuerkonto, ALT.i_nnf_skontokonto, ALT.i_zusatz, ALT.i_nnf_eg_konto, ALT.i_naf_konto , ALT.dec_abzugsfaehig, ALT.c_absender, ALT.c_abs_bank, ALT.c_abs_blz, ALT.c_abs_knr, ALT.c_empfaenger, ALT.c_verwend, ALT.c_verwend2, ALT.c_verwend3, ALT.c_esr, ALT.si_kennung, ALT.i_st_input, ALT.i_verdichtet, ALT.i_intern, ALT.c_dms_docid, ALT.i_beleg_refid, ALT.i_buchschab_id, ALT.d_gueltig_bis, ALT.c_sepa_mandat, ALT.c_ustidnr, ALT.i_quelle_modul, ALT.c_quelle_maske, ALT.si_manipulation, ALT.dt_creation, USER ,'D' ,CURRENT year to fraction(3), ALT.c_protokoll_id)
	);
	/
#ENDIF
